"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _constants = require("../../utils/constants/constants");
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _Spacer = _interopRequireDefault(require("../CustomView/Spacer"));
var _CustomImage = _interopRequireDefault(require("../CustomView/CustomImage"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const IMAGE_DEFAULT_HEIGHT = (0, _utils.vs)(112);
const CustomCardList = _ref => {
  var _restProps$currentMes;
  let {
    onButtonPress,
    // lightboxProps,
    ...restProps
  } = _ref;
  const renderCardItem = (itm, idx) => {
    var _itm$buttons;
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      key: `card-item-${itm === null || itm === void 0 ? void 0 : itm.title}-${idx}`,
      style: styles.card
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.contentWrapper
    }, itm !== null && itm !== void 0 && itm['image-url'] ? /*#__PURE__*/_react.default.createElement(_CustomImage.default, {
      uri: itm === null || itm === void 0 ? void 0 : itm['image-url'],
      fixedHeight: IMAGE_DEFAULT_HEIGHT
    }) : undefined, /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 10
    }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.title
    }, itm === null || itm === void 0 ? void 0 : itm.title), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 10
    }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.subTitle
    }, itm === null || itm === void 0 ? void 0 : itm['sub-title']), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 10
    }), itm === null || itm === void 0 || (_itm$buttons = itm.buttons) === null || _itm$buttons === void 0 ? void 0 : _itm$buttons.map((btn, bIdx) => {
      return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
        key: `card-btn-${btn === null || btn === void 0 ? void 0 : btn.label}-${bIdx}`,
        style: styles.cardButton,
        onPress: () => {
          onButtonPress === null || onButtonPress === void 0 ? void 0 : onButtonPress(btn, idx);
        }
      }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
        style: styles.buttonText
      }, btn === null || btn === void 0 ? void 0 : btn.label));
    })));
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, {
    horizontal: true,
    style: styles.flatList,
    contentContainerStyle: styles.flexGrowOne,
    data: (restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.cards) ?? [],
    renderItem: _ref2 => {
      let {
        item: it,
        index: idx
      } = _ref2;
      return renderCardItem(it, idx);
    }
  });
};
var _default = CustomCardList;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  flexGrowOne: {
    flexGrow: 1
  },
  flatList: {
    flex: 1,
    minHeight: (0, _utils.vs)(140)
  },
  card: {
    width: (0, _utils.s)(237),
    justifyContent: 'space-between',
    alignItems: 'center',
    backgroundColor: _colors.default.white,
    borderRadius: (0, _utils.st)(5),
    padding: (0, _utils.st)(10),
    marginHorizontal: (0, _utils.s)(10)
  },
  contentWrapper: {
    width: '100%',
    backgroundColor: _colors.default.porcelian
  },
  image: {
    // width: s(214),
    height: (0, _utils.vs)(137),
    borderRadius: (0, _utils.st)(5),
    margin: (0, _utils.st)(3),
    resizeMode: 'cover'
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  cardButton: {
    minHeight: (0, _utils.vs)(36),
    backgroundColor: _colors.default.white,
    borderRadius: (0, _utils.st)(20),
    paddingVertical: (0, _utils.vs)(10),
    paddingHorizontal: (0, _utils.s)(8),
    marginHorizontal: (0, _utils.s)(8),
    marginBottom: (0, _utils.vs)(8),
    justifyContent: 'center',
    alignItems: 'center'
  },
  buttonText: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '700' : 'bold',
    fontSize: (0, _utils.st)(14),
    lineHeight: (0, _utils.st)(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  title: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '700' : 'bold',
    fontSize: (0, _utils.st)(14),
    lineHeight: (0, _utils.st)(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center',
    alignSelf: 'flex-start'
  },
  subTitle: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center',
    alignSelf: 'flex-start'
  }
});
//# sourceMappingURL=CustomCardList.js.map