"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _CustomArrow = _interopRequireDefault(require("../CustomView/CustomArrow"));
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _constants = require("../../utils/constants/constants");
var _CustomDateTimePicker = _interopRequireDefault(require("../CustomView/CustomDateTimePicker/CustomDateTimePicker"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const CustomDateTimePickerMessage = _ref => {
  var _restProps$currentMes;
  let {
    pickerProps,
    onConfirm,
    ...restProps
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_CustomArrow.default, {
    position: restProps === null || restProps === void 0 ? void 0 : restProps.position,
    borderColor: _colors.default.blueBayoux20,
    borderWidth: 1
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.bubble
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.messageText, (restProps === null || restProps === void 0 ? void 0 : restProps.position) === 'right' ? styles.messageTextRight : undefined]
  }, restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.text), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.separator
  }), /*#__PURE__*/_react.default.createElement(_CustomDateTimePicker.default, {
    pickerProps: pickerProps,
    onConfirm: onConfirm
  })));
};
var _default = CustomDateTimePickerMessage;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  flexGrowOne: {
    flexGrow: 1
  },
  flatList: {
    flex: 1
  },
  flatlistContent: {
    justifyContent: 'flex-start'
  },
  bubble: {
    maxWidth: (0, _utils.s)(251),
    justifyContent: 'flex-start',
    borderWidth: 1,
    borderColor: _colors.default.blueBayoux20,
    // alignItems: 'center',
    backgroundColor: _colors.default.white,
    borderRadius: (0, _utils.st)(5),
    paddingVertical: (0, _utils.vs)(6),
    paddingHorizontal: (0, _utils.s)(10),
    //FIXME: show empty msg
    minHeight: (0, _utils.vs)(30),
    minWidth: (0, _utils.s)(20),
    marginHorizontal: (0, _utils.s)(2)
  },
  button: {
    backgroundColor: _colors.default.mountainMeadow,
    borderRadius: (0, _utils.st)(5),
    paddingVertical: (0, _utils.vs)(10),
    paddingHorizontal: (0, _utils.vs)(8),
    marginRight: (0, _utils.s)(10),
    marginBottom: (0, _utils.vs)(8)
  },
  image: {
    width: (0, _utils.st)(48),
    height: (0, _utils.st)(48)
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  messageText: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02,
    alignSelf: 'flex-start'
  },
  messageTextRight: {
    color: _colors.default.white
  },
  separator: {
    height: 1,
    width: '100%',
    backgroundColor: _colors.default.blueBayoux20,
    marginVertical: (0, _utils.vs)(4)
  },
  buttonText: {
    color: _colors.default.white,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02
  }
});
//# sourceMappingURL=CustomDateTimePickerMessage.js.map