"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _SvgCustomFile = _interopRequireDefault(require("../../assets/png/ReactSvgs/SvgCustomFile"));
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _constants = require("../../utils/constants/constants");
var _Spacer = _interopRequireDefault(require("../CustomView/Spacer"));
var _queryString = _interopRequireDefault(require("query-string"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const CustomFile = _ref => {
  let {
    ...restProps
  } = _ref;
  //States
  const [fileSize, setFileSize] = (0, _react.useState)('calculating...');
  //Vars that used multi times
  const {
    position,
    currentMessage
  } = restProps;
  //use queryString is to prevent Url with queries
  const pathReader = _queryString.default.parseUrl((currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.file) ?? '');
  const filename = _utils.StringHelper.getFileName((pathReader === null || pathReader === void 0 ? void 0 : pathReader.url) ?? '');
  const ext = _utils.StringHelper.getFileExtensions((pathReader === null || pathReader === void 0 ? void 0 : pathReader.url) ?? '');
  const isLeft = position === 'left';
  //Effects
  (0, _react.useEffect)(() => {
    var _currentMessage$file;
    if (currentMessage !== null && currentMessage !== void 0 && (_currentMessage$file = currentMessage.file) !== null && _currentMessage$file !== void 0 && (_currentMessage$file = _currentMessage$file.toLowerCase()) !== null && _currentMessage$file !== void 0 && _currentMessage$file.startsWith('http')) {
      fetchFileSize(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.file);
    }
  }, [currentMessage]);
  const fetchFileSize = async path => {
    const blob = await _utils.FileHelper.uriToBlob(path);
    setFileSize(_utils.StringHelper.getFileSize(blob.size));
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_SvgCustomFile.default, {
    fileExtensions: ext
  }), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    width: 16
  }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.textContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.fileName, {
      color: isLeft ? _colors.default.shark : _colors.default.white
    }],
    numberOfLines: 1,
    ellipsizeMode: 'middle'
  }, filename), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.fileSize, {
      color: isLeft ? _colors.default.grayChateau : _colors.default.white
    }],
    numberOfLines: 1,
    ellipsizeMode: 'middle'
  }, fileSize ? fileSize : 'calculating...')), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    width: 40
  }));
};
var _default = CustomFile;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    flexDirection: 'row',
    margin: (0, _utils.st)(5)
  },
  textContainer: {
    width: (0, _utils.s)(104)
  },
  fileName: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02
  },
  fileSize: {
    color: _colors.default.grayChateau,
    fontWeight: _constants.isIOS ? '400' : 'normal',
    fontSize: (0, _utils.st)(10),
    lineHeight: (0, _utils.st)(14),
    letterSpacing: -0.02
  }
});
//# sourceMappingURL=CustomFile.js.map