"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeGiftedChat = require("react-native-gifted-chat");
var _reactNativeImageCropPicker = _interopRequireDefault(require("react-native-image-crop-picker"));
var _reactNativeDocumentPicker = _interopRequireDefault(require("react-native-document-picker"));
var _utils = require("../../../utils");
var _image = _interopRequireDefault(require("../../../utils/theme/image"));
var _colors = _interopRequireDefault(require("../../../utils/theme/colors"));
var _constants = require("../../../utils/constants/constants");
var _Spacer = _interopRequireDefault(require("../../CustomView/Spacer"));
var _AttachmentPreview = _interopRequireDefault(require("./components/AttachmentPreview"));
var _RecorderPlayerResponsiveView = _interopRequireDefault(require("../../CustomView/RecorderPlayer/RecorderPlayerResponsiveView"));
var _RecorderPlayerResponsiveManager = _interopRequireDefault(require("../../CustomView/RecorderPlayer/RecorderPlayerResponsiveManager"));
var _RemoteStorageModule = _interopRequireDefault(require("../../../services/RemoteStorage/RemoteStorageModule"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const CustomInputToolbar = _ref => {
  let {
    toolbarCustomOptions = DEFAULT_TOOLBAR_OPTIONS,
    allowMultiAttachments,
    onAddAttachment,
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    onRemoveAttachment,
    ...restProps
  } = _ref;
  const [showActions, setShowActions] = (0, _react.useState)(false);
  const [attachments, setAttachments] = (0, _react.useState)([]);
  const handleAddAttachment = (attachment, actionProps) => {
    if (allowMultiAttachments) {
      attachments.push(attachment);
      setAttachments(attachments);
    } else {
      setAttachments([attachment]);
    }
    onAddAttachment === null || onAddAttachment === void 0 ? void 0 : onAddAttachment(attachment, actionProps);
  };
  const handleUploadAttachment = async () => {
    const uploadResult = [];
    for (let att of attachments) {
      try {
        const result = await _RemoteStorageModule.default.uploadFile(att.uri, `${_utils.UuidHelper.initUUID()}_${Date.now()}_${att.name}`);
        console.log(result);
        uploadResult.push(result);
      } catch (e) {
        console.log(e);
      }
    }
    setAttachments([]);
    return uploadResult;
  };
  const renderActionItem = (it, idx) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      key: `action-item-${it === null || it === void 0 ? void 0 : it.label}-${idx}`,
      style: [styles.actionItem,
      // eslint-disable-next-line react-native/no-inline-styles
      {
        marginRight: idx === (toolbarCustomOptions === null || toolbarCustomOptions === void 0 ? void 0 : toolbarCustomOptions.length) - 1 ? 0 : 30
      }],
      onPress: async () => {
        setShowActions(false);
        let result;
        try {
          var _it$onPress;
          result = await (it === null || it === void 0 || (_it$onPress = it.onPress) === null || _it$onPress === void 0 ? void 0 : _it$onPress.call(it));
        } catch (e) {}
        console.log(result);
        if (result) {
          handleAddAttachment(result, it);
        }
      }
    }, it !== null && it !== void 0 && it.image ? /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: it === null || it === void 0 ? void 0 : it.image,
      resizeMode: 'contain',
      style: styles.actionImage
    }) : undefined, /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 8
    }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.actionText
    }, it === null || it === void 0 ? void 0 : it.label));
  };
  const renderActionsBar = () => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
      horizontal: true,
      style: styles.actionsBar,
      contentContainerStyle: styles.actionBarContentContainer
    }, toolbarCustomOptions === null || toolbarCustomOptions === void 0 ? void 0 : toolbarCustomOptions.map((it, idx) => renderActionItem(it, idx)));
  };
  const renderActionButton = () => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: styles.actionWrapper,
      onPress: () => {
        setShowActions(prev => !prev);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: [styles.iconText]
    }, "+"));
  };
  const renderInputToolbar = () => {
    return /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.InputToolbar, _extends({}, restProps, {
      containerStyle: styles.inputContainer
      // renderActions={actionsProps => {
      //   return (
      //     <Actions
      //       {...actionsProps}
      //     />
      //   );
      // }}
      ,
      renderSend: sendProps => /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.Send, _extends({}, sendProps, {
        containerStyle: styles.sendButton,
        alwaysShowSend: !!(attachments !== null && attachments !== void 0 && attachments.length),
        text: (sendProps === null || sendProps === void 0 ? void 0 : sendProps.text) || (attachments !== null && attachments !== void 0 && attachments.length ? HAS_ATTACHMENT_FLAG : undefined),
        onSend: async (messages, shouldResetInputToolbar) => {
          var _messages$, _sendProps$onSend;
          // console.log('seeeeens', messages, shouldResetInputToolbar)
          Array.isArray(messages) ? messages === null || messages === void 0 || (_messages$ = messages[0]) === null || _messages$ === void 0 ? void 0 : _messages$.text : messages === null || messages === void 0 ? void 0 : messages.text;
          if (attachments !== null && attachments !== void 0 && attachments.length && HAS_ATTACHMENT_FLAG) {
            let formattedMsgs;
            const uploadResult = await handleUploadAttachment();

            //FIXME: only support 1 attachment for now (uploadResult?.[0])
            if (Array.isArray(messages) && messages) {
              const idx = messages.findIndex(it => it.text === HAS_ATTACHMENT_FLAG);
              if (idx >= 0) {
                formattedMsgs = messages;
                //@ts-ignore
                formattedMsgs[idx].text = uploadResult === null || uploadResult === void 0 ? void 0 : uploadResult[0];
              }
            } else {
              formattedMsgs = messages;
              formattedMsgs.text = uploadResult === null || uploadResult === void 0 ? void 0 : uploadResult[0];
            }
          }
          sendProps === null || sendProps === void 0 || (_sendProps$onSend = sendProps.onSend) === null || _sendProps$onSend === void 0 ? void 0 : _sendProps$onSend.call(sendProps, messages, shouldResetInputToolbar);
        }
      }), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
        source: _image.default.ic_send_plane,
        style: styles.sendIcon,
        resizeMode: 'contain'
      })),
      renderComposer: composerProps => /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.Composer, _extends({}, composerProps, {
        textInputStyle: styles.inputText
      }))
    }));
  };
  const renderAttachment = () => {
    if (attachments !== null && attachments !== void 0 && attachments.length) {
      //FIXME: dummy UI
      return /*#__PURE__*/_react.default.createElement(_AttachmentPreview.default, {
        style: styles.attachments,
        attachments: attachments,
        onClose: () => {
          setAttachments([]);
        },
        onRemove: (itm, _idx) => {
          const newAtts = [...attachments].filter(it => (it === null || it === void 0 ? void 0 : it.uri) !== (itm === null || itm === void 0 ? void 0 : itm.uri));
          setAttachments(newAtts);
        }
      });
    }
    return undefined;
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.Pressable, {
    style: styles.container,
    onPress: () => {
      _reactNative.Keyboard.dismiss();
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, null, renderAttachment(), showActions ? renderActionsBar() : undefined), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.inputRow
  }, renderActionButton(), renderInputToolbar()), /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_RecorderPlayerResponsiveView.default, null)));
};
var _default = CustomInputToolbar;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1
  },
  inputRow: {
    flex: 1,
    flexDirection: 'row',
    alignItems: 'center',
    borderWidth: (0, _utils.s)(1),
    borderColor: _colors.default.silverChalice40
  },
  actionWrapper: {
    width: (0, _utils.s)(32),
    borderRadius: 0,
    backgroundColor: _colors.default.porcelian,
    justifyContent: 'center',
    alignItems: 'center',
    bottom: 0,
    left: 0,
    right: 0
  },
  actionsBar: {
    flexDirection: 'row',
    position: 'absolute',
    bottom: (0, _utils.vs)(10),
    left: 0,
    right: 0,
    backgroundColor: _colors.default.white,
    borderRadius: (0, _utils.st)(5)
  },
  actionBarContentContainer: {
    flexGrow: 1,
    justifyContent: 'center',
    alignItems: 'center',
    paddingVertical: (0, _utils.vs)(15)
  },
  actionItem: {
    justifyContent: 'center',
    alignItems: 'center'
  },
  actionImage: {
    width: (0, _utils.st)(45),
    height: (0, _utils.st)(45)
  },
  actionText: {
    color: _colors.default.jumbo,
    fontWeight: 'normal',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(18),
    alignSelf: 'center',
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  inputContainer: {
    borderLeftWidth: (0, _utils.s)(1),
    borderLeftColor: _colors.default.silverChalice40,
    //Workaround to remove current style
    top: (0, _utils.vs)(1),
    borderTopWidth: 0,
    position: 'absolute',
    bottom: 0,
    left: (0, _utils.s)(40),
    right: 0
  },
  sendButton: {
    width: (0, _utils.s)(32),
    paddingRight: (0, _utils.s)(10),
    justifyContent: 'center',
    alignItems: 'center',
    alignSelf: 'center'
  },
  sendIcon: {
    width: (0, _utils.st)(15),
    height: (0, _utils.st)(15)
  },
  userAvatar: {
    width: 0,
    height: 0
  },
  iconText: {
    flex: 1,
    color: _colors.default.jumbo,
    fontWeight: 'normal',
    fontSize: (0, _utils.st)(28),
    textAlign: 'center',
    textAlignVertical: 'center',
    marginLeft: (0, _utils.s)(6)
  },
  attachments: {
    position: 'absolute',
    bottom: 0,
    left: 0,
    right: 0,
    backgroundColor: _colors.default.porcelian,
    borderRadius: (0, _utils.st)(5)
  },
  inputText: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    textAlign: 'left',
    textAlignVertical: 'center'
  }
});
const DEFAULT_TOOLBAR_OPTIONS = [{
  label: 'Image',
  image: _image.default.ic_pick_image,
  onPress: async () => {
    try {
      const image = await _reactNativeImageCropPicker.default.openPicker({
        cropping: false,
        mediaType: 'photo'
      });
      let fileName = _constants.isIOS ? image.filename : _utils.StringHelper.getFileName(image.path);
      // const imageBase64 = `data:${image.mime};base64,${image?.data}`;
      return {
        uri: image.path,
        type: image.mime,
        name: fileName ?? ''
      };
    } catch (e) {
      console.log('image error', e);
      return Promise.reject(e);
    }
  }
}, {
  label: 'File',
  image: _image.default.ic_pick_file,
  onPress: async () => {
    try {
      const pickerResult = await _reactNativeDocumentPicker.default.pickSingle({
        presentationStyle: 'fullScreen',
        copyTo: 'cachesDirectory'
      });
      return {
        uri: (pickerResult === null || pickerResult === void 0 ? void 0 : pickerResult.fileCopyUri) ?? '',
        type: (pickerResult === null || pickerResult === void 0 ? void 0 : pickerResult.type) ?? '',
        name: (pickerResult === null || pickerResult === void 0 ? void 0 : pickerResult.name) ?? ''
      };
    } catch (e) {
      return Promise.reject(e);
    }
  }
}, {
  label: 'Video',
  image: _image.default.ic_pick_video,
  onPress: async () => {
    try {
      const video = await _reactNativeImageCropPicker.default.openPicker({
        mediaType: 'video'
      });
      let fileName = _constants.isIOS ? video.filename : _utils.StringHelper.getFileName(video.path);
      return {
        uri: video.path,
        type: video.mime,
        name: fileName ?? ''
      };
    } catch (e) {
      return Promise.reject(e);
    }
  }
}, {
  label: 'Record',
  image: _image.default.ic_pick_record,
  onPress: async () => {
    try {
      const recordResult = await _RecorderPlayerResponsiveManager.default.showPopupAsync({
        type: 'record',
        positionAt: {
          left: 0,
          right: 0,
          bottom: 0
        }
      });
      console.log(recordResult);
      return {
        uri: recordResult,
        type: 'audio/m4a',
        name: _utils.StringHelper.getFileName(recordResult) ?? ''
      };
    } catch (e) {
      console.log(e);
      return Promise.reject(e);
    }
  }
}];

/**
 * Just a unique flag to use in text to trigger `onSend`,
 * since `onSend` function only triggered when text is not empty
 */
const HAS_ATTACHMENT_FLAG = 'HAS_ATTACHMENT_FLAG_36c3c4a9-811d-50ef-9605-894619b2081d';
//# sourceMappingURL=CustomInputToolbar.js.map