"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../../../utils");
var _colors = _interopRequireDefault(require("../../../../utils/theme/colors"));
var _reactNativeAutoHeightImage = _interopRequireDefault(require("react-native-auto-height-image"));
var _image = _interopRequireDefault(require("../../../../utils/theme/image"));
var _reactNativeVideo = _interopRequireDefault(require("react-native-video"));
var _reactNativePdf = _interopRequireDefault(require("react-native-pdf"));
var _constants = require("../../../../utils/constants/constants");
var _Spacer = _interopRequireDefault(require("../../../CustomView/Spacer"));
var _PreviewAudioPlayer = _interopRequireDefault(require("./PreviewAudioPlayer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const AttachmentPreview = _ref => {
  let {
    attachments,
    onClose,
    onRemove,
    style,
    ...restProps
  } = _ref;
  //States
  const [paused, setPaused] = (0, _react.useState)(true);
  //Refs
  const videoRef = (0, _react.useRef)(null);
  const renderAttachmentImage = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/_react.default.createElement(_reactNativeAutoHeightImage.default, {
      width: _utils.screenWidth - styles.container.padding * 2,
      source: {
        uri: itm.uri
      },
      resizeMode: 'contain',
      style: styles.imageAtt
    }));
  };
  const renderAttachmentVideo = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.videoContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNativeVideo.default, {
      ref: videoRef,
      source: {
        uri: itm.uri
      },
      resizeMode: 'contain',
      style: styles.videoAtt,
      onLoad: _videoData => {
        var _videoRef$current;
        videoRef === null || videoRef === void 0 || (_videoRef$current = videoRef.current) === null || _videoRef$current === void 0 ? void 0 : _videoRef$current.seek(0);
        setPaused(true);
      },
      onLoadStart: () => {},
      paused: paused,
      controls: true
    })));
  };
  const renderAttachmentPDF = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.title,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.name), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/_react.default.createElement(_reactNativePdf.default, {
      source: {
        uri: itm.uri
      },
      onLoadComplete: (numberOfPages, _filePath) => {
        console.log(`Number of pages: ${numberOfPages}`);
      },
      onPageChanged: (page, _numberOfPages) => {
        console.log(`Current page: ${page}`);
      },
      onError: error => {
        console.log(error);
      },
      onPressLink: uri => {
        console.log(`Link pressed: ${uri}`);
      },
      style: styles.pdfAtt
    }));
  };
  const renderAttachmentAudioPlayer = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_PreviewAudioPlayer.default, {
      audioPath: itm === null || itm === void 0 ? void 0 : itm.uri,
      onRemove: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 20
    }));
  };
  const renderAttachmentUnknown = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.title,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.name), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 20
    }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.text,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.type), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 20
    }));
  };
  const renderAttachmentItem = (itm, idx) => {
    let content;
    const lowerCaseType = itm.type.toLowerCase();
    if (lowerCaseType.includes('image')) {
      content = renderAttachmentImage(itm, idx);
    } else if (lowerCaseType.includes('video')) {
      content = renderAttachmentVideo(itm, idx);
    } else if (lowerCaseType.includes('pdf')) {
      content = renderAttachmentPDF(itm, idx);
    } else if (lowerCaseType.includes('audio')) {
      content = renderAttachmentAudioPlayer(itm, idx);
    } else {
      content = renderAttachmentUnknown(itm, idx);
    }
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      key: `attachment-${itm}-${idx}`
    }, content);
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({
    style: [styles.container, style]
  }, restProps), attachments === null || attachments === void 0 ? void 0 : attachments.map((it, idx) => renderAttachmentItem(it, idx)));
};
var _default = AttachmentPreview;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    padding: (0, _utils.st)(20),
    maxHeight: _utils.screenHeight - (0, _utils.vs)(100)
  },
  rowContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  imageCloseBtn: {
    width: (0, _utils.st)(17),
    height: (0, _utils.st)(17)
  },
  imageTrashBtn: {
    width: (0, _utils.st)(20),
    height: (0, _utils.st)(20)
  },
  imageAtt: {
    maxHeight: _utils.screenHeight - (0, _utils.vs)(280),
    marginVertical: (0, _utils.vs)(60),
    borderRadius: (0, _utils.st)(5)
  },
  videoContainer: {
    flex: 1,
    marginVertical: (0, _utils.vs)(60)
  },
  videoAtt: {
    borderRadius: (0, _utils.st)(5),
    width: _utils.screenWidth - (0, _utils.st)(20) * 2,
    minHeight: (_utils.screenWidth - (0, _utils.st)(20) * 2) * 9 / 16 + (0, _utils.vs)(80) // 16:9 frames + expand 80h
  },

  pdfAtt: {
    // flex: 1,
    width: _utils.screenWidth - (0, _utils.st)(20) * 2,
    height: _utils.screenHeight - (0, _utils.vs)(360),
    marginVertical: (0, _utils.vs)(10),
    borderRadius: (0, _utils.st)(5)
  },
  title: {
    fontSize: (0, _utils.st)(16),
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  text: {
    fontSize: (0, _utils.st)(12),
    color: _colors.default.black,
    textAlign: 'center',
    textAlignVertical: 'center'
  }
});
//# sourceMappingURL=AttachmentPreview.js.map