"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _moment = _interopRequireDefault(require("moment"));
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeGiftedChat = require("react-native-gifted-chat");
var _constants = require("../../utils/constants/constants");
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _utils = require("../../utils");
var _CustomCardList = _interopRequireDefault(require("./CustomCardList"));
var _CustomArrow = _interopRequireDefault(require("../CustomView/CustomArrow"));
var _CustomQuickReply = _interopRequireDefault(require("./CustomQuickReply"));
var _CustomDateTimePickerMessage = _interopRequireDefault(require("./CustomDateTimePickerMessage"));
var _AppConstants = require("../../utils/constants/AppConstants");
var _VideoPlayer = _interopRequireDefault(require("../CustomView/VideoPlayer"));
var _AudioPlayer = _interopRequireDefault(require("../CustomView/AudioPlayer"));
var _CustomFile = _interopRequireDefault(require("./CustomFile"));
var _queryString = _interopRequireDefault(require("query-string"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const CustomMessage = _ref => {
  var _currentMessage$user, _localProps$nextMessa;
  let {
    onCardButtonPress,
    onQuickReplyItemPress,
    onDateTimeSelect,
    ...restProps
  } = _ref;
  //States
  const [localProps, setLocalProps] = (0, _react.useState)(restProps);
  //Vars
  const currentMessage = localProps.currentMessage;
  const sameUserInNextMessage = (currentMessage === null || currentMessage === void 0 || (_currentMessage$user = currentMessage.user) === null || _currentMessage$user === void 0 ? void 0 : _currentMessage$user._id) === ((_localProps$nextMessa = localProps.nextMessage) === null || _localProps$nextMessa === void 0 || (_localProps$nextMessa = _localProps$nextMessa.user) === null || _localProps$nextMessa === void 0 ? void 0 : _localProps$nextMessa._id);
  // const isCurrentUser = currentUserId == currentMessage?.user?._id;
  const orientationStyle = (localProps === null || localProps === void 0 ? void 0 : localProps.position) === 'right' ? styles.right : styles.left;
  //Effects
  (0, _react.useEffect)(() => {
    reformatProps();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  const reformatProps = async () => {
    let newProps = localProps;
    let blob;
    if (currentMessage !== null && currentMessage !== void 0 && currentMessage.text) {
      var _lowerMsg$split, _blob;
      const pathReader = _queryString.default.parseUrl(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text);
      const lowerMsg = ((pathReader === null || pathReader === void 0 ? void 0 : pathReader.url) ?? '').toLowerCase();
      const ext = _utils.StringHelper.getFileExtensions(lowerMsg);
      //Show temp UI (three dot) if the message is link with extenstion
      if (ext && _AppConstants.URL_REGEX.test(lowerMsg) && (lowerMsg === null || lowerMsg === void 0 || (_lowerMsg$split = lowerMsg.split(/[/|\\\\]/)) === null || _lowerMsg$split === void 0 ? void 0 : _lowerMsg$split.length) >= 4) {
        let tempProps = {
          ...localProps,
          currentMessage: {
            ...currentMessage,
            text: '...'
          }
        };
        setLocalProps(tempProps);
      }
      try {
        blob = await _utils.FileHelper.uriToBlob(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text);
      } catch (e) {}
      if ((_blob = blob) !== null && _blob !== void 0 && _blob.size) {
        if (_AppConstants.IMAGE_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              image: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else if (_AppConstants.AUDIO_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              audio: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else if (_AppConstants.VIDEO_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              video: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              file: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        }
      }
    }
    setLocalProps(newProps);
  };
  const renderBubble = () => {
    return /*#__PURE__*/_react.default.createElement(_CustomArrow.default, {
      position: localProps === null || localProps === void 0 ? void 0 : localProps.position,
      borderColor: _colors.default.blueBayoux20,
      borderWidth: 1
    }, /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.Bubble, _extends({}, localProps, {
      renderTime: _timeProps => undefined,
      wrapperStyle: {
        left: [styles.bubble, styles.bubbleLeft],
        right: [styles.bubble, styles.bubbleRight]
      },
      textStyle: {
        left: styles.messageText,
        right: [styles.messageText, styles.messageTextRight]
      },
      renderMessageVideo: videoProps => {
        var _videoProps$currentMe;
        const uri = (_videoProps$currentMe = videoProps.currentMessage) === null || _videoProps$currentMe === void 0 ? void 0 : _videoProps$currentMe.video;
        if (!uri) {
          return /*#__PURE__*/_react.default.createElement(_reactNative.View, null);
        }
        return /*#__PURE__*/_react.default.createElement(_VideoPlayer.default, {
          uri: uri,
          style: styles.video
        });
      },
      renderMessageAudio: audioProps => {
        var _audioProps$currentMe;
        const uri = (_audioProps$currentMe = audioProps.currentMessage) === null || _audioProps$currentMe === void 0 ? void 0 : _audioProps$currentMe.audio;
        if (!uri) {
          return /*#__PURE__*/_react.default.createElement(_reactNative.View, null);
        }
        return /*#__PURE__*/_react.default.createElement(_AudioPlayer.default, {
          uri: uri
        });
      },
      renderCustomView: customProps => {
        var _customProps$currentM;
        if (customProps !== null && customProps !== void 0 && (_customProps$currentM = customProps.currentMessage) !== null && _customProps$currentM !== void 0 && _customProps$currentM.file) {
          return /*#__PURE__*/_react.default.createElement(_CustomFile.default, _extends({}, customProps, {
            wrapperStyle: {
              left: [styles.bubble, styles.bubbleLeft],
              right: [styles.bubble, styles.bubbleRight]
            }
          }));
        }
      }
    })));
  };
  const renderContent = () => {
    var _localProps$currentMe;
    switch (localProps === null || localProps === void 0 || (_localProps$currentMe = localProps.currentMessage) === null || _localProps$currentMe === void 0 ? void 0 : _localProps$currentMe.templateType) {
      case 'card':
        {
          return /*#__PURE__*/_react.default.createElement(_CustomCardList.default, _extends({}, localProps, {
            onButtonPress: (btn, idx) => {
              onCardButtonPress === null || onCardButtonPress === void 0 ? void 0 : onCardButtonPress(btn, idx);
            }
          }));
        }
      case 'quick_reply':
        {
          var _localProps$currentMe2;
          if (localProps !== null && localProps !== void 0 && (_localProps$currentMe2 = localProps.currentMessage) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2.quickReplies) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2.values) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2[0]) !== null && _localProps$currentMe2 !== void 0 && _localProps$currentMe2.value) {
            return /*#__PURE__*/_react.default.createElement(_CustomQuickReply.default, _extends({}, localProps, {
              onCutomQuickReply: (itm, idx) => {
                onQuickReplyItemPress === null || onQuickReplyItemPress === void 0 ? void 0 : onQuickReplyItemPress(itm, idx);
              }
            }));
          }
          return renderBubble();
        }
      case 'datetime':
        {
          var _localProps$currentMe3;
          if (localProps !== null && localProps !== void 0 && (_localProps$currentMe3 = localProps.currentMessage) !== null && _localProps$currentMe3 !== void 0 && _localProps$currentMe3.datetime) {
            var _localProps$currentMe4;
            const pickerProps = localProps === null || localProps === void 0 || (_localProps$currentMe4 = localProps.currentMessage) === null || _localProps$currentMe4 === void 0 ? void 0 : _localProps$currentMe4.datetime;
            return /*#__PURE__*/_react.default.createElement(_CustomDateTimePickerMessage.default, _extends({}, localProps, {
              pickerProps: pickerProps,
              onConfirm: (dateTime, endDate) => {
                onDateTimeSelect === null || onDateTimeSelect === void 0 ? void 0 : onDateTimeSelect(dateTime, endDate, pickerProps);
              }
            }));
          }
          return renderBubble();
        }
      default:
        {
          return renderBubble();
        }
    }
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.container, orientationStyle]
  }, renderContent(), !sameUserInNextMessage ? /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.messageTime, orientationStyle]
  }, (0, _moment.default)(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.createdAt).format('LT'))) : undefined);
};
var _default = CustomMessage;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {},
  bubble: {
    justifyContent: 'center',
    borderRadius: (0, _utils.st)(5),
    //FIXME: show empty msg
    minHeight: (0, _utils.vs)(30),
    minWidth: (0, _utils.s)(20),
    borderWidth: (0, _utils.s)(1),
    borderColor: _colors.default.blueBayoux20
  },
  bubbleLeft: {
    backgroundColor: _colors.default.white,
    marginLeft: (0, _utils.s)(2)
  },
  bubbleRight: {
    backgroundColor: _colors.default.blueBayoux,
    marginRight: (0, _utils.s)(2)
  },
  right: {
    flex: 1,
    alignSelf: 'flex-end'
  },
  left: {
    flex: 1,
    alignSelf: 'flex-start'
  },
  messageTime: {
    paddingHorizontal: (0, _utils.s)(12),
    color: _colors.default.grayChateau,
    fontWeight: _constants.isIOS ? '400' : 'normal',
    fontSize: (0, _utils.st)(10),
    lineHeight: (0, _utils.st)(14),
    letterSpacing: -0.02,
    marginTop: (0, _utils.vs)(2)
  },
  messageText: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02
  },
  messageTextRight: {
    color: _colors.default.white
  },
  video: {
    margin: (0, _utils.st)(5),
    borderRadius: (0, _utils.st)(5)
  }
});
//# sourceMappingURL=CustomMessage.js.map