"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeGiftedChat = require("react-native-gifted-chat");
var _utils = require("../../utils");
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const IMAGE_DEFAULT_WIDTH = (0, _utils.s)(260);
const IMAGE_DEFAULT_HEIGHT = (0, _utils.vs)(150);
const CustomMessageImage = _ref => {
  let {
    ...restProps
  } = _ref;
  //States
  const [imageWidth, setImageWidth] = (0, _react.useState)(0);
  const [imageheight, setImageHeight] = (0, _react.useState)(0);
  const [isImageFetching, setIsImageFetching] = (0, _react.useState)();
  //Vars
  const calculatedHeight = imageheight * IMAGE_DEFAULT_WIDTH / (imageWidth ?? 1);
  //Effects
  (0, _react.useEffect)(() => {
    getSize();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [restProps === null || restProps === void 0 ? void 0 : restProps.currentMessage]);
  const getSize = async () => {
    var _restProps$currentMes;
    const uri = restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.image;
    if (uri) {
      _reactNative.Image.getSize(uri, (width, height) => {
        // console.log(width, height);
        setImageWidth(isNaN(width) ? IMAGE_DEFAULT_WIDTH : width);
        setImageHeight(isNaN(height) ? IMAGE_DEFAULT_HEIGHT : height);
      }, e => {
        console.log(e);
        setImageWidth(IMAGE_DEFAULT_WIDTH);
        setImageHeight(IMAGE_DEFAULT_HEIGHT);
      });
    }
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.MessageImage, _extends({}, restProps, {
    imageStyle: [styles.image, {
      width: IMAGE_DEFAULT_WIDTH,
      height: calculatedHeight ? calculatedHeight : IMAGE_DEFAULT_HEIGHT
    }],
    imageProps: {
      onLoadStart: () => {
        if (isImageFetching !== false) {
          // false mean it already loaded
          setIsImageFetching(true);
        }
      },
      onLoadEnd: () => {
        setIsImageFetching(false);
      }
    },
    containerStyle: styles.container
  })), !imageWidth || !imageheight || isImageFetching ? /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
    style: styles.activityIndicator,
    color: _colors.default.mountainMeadow
  }) : undefined);
};
var _default = CustomMessageImage;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    borderRadius: (0, _utils.st)(5)
  },
  image: {
    width: (0, _utils.s)(260),
    height: (0, _utils.vs)(150),
    borderRadius: (0, _utils.st)(5),
    margin: (0, _utils.st)(5)
  },
  activityIndicator: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0,
    padding: (0, _utils.st)(10)
  }
});
//# sourceMappingURL=CustomMessageImage.js.map