"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _CustomArrow = _interopRequireDefault(require("../CustomView/CustomArrow"));
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _constants = require("../../utils/constants/constants");
var _CustomImage = _interopRequireDefault(require("../CustomView/CustomImage"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const IMAGE_DEFAULT_HEIGHT = (0, _utils.vs)(112);
const CustomQuickReply = _ref => {
  var _restProps$currentMes, _restProps$currentMes2;
  let {
    onCutomQuickReply,
    // lightboxProps,
    ...restProps
  } = _ref;
  const quickReplies = (restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 || (_restProps$currentMes = _restProps$currentMes.quickReplies) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.values) ?? [];
  const renderQuickReplyItem = (itm, idx) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      key: `quickreply-item-${itm === null || itm === void 0 ? void 0 : itm.title}-${idx}`
    }, itm !== null && itm !== void 0 && itm['image-uri'] ? /*#__PURE__*/_react.default.createElement(_CustomImage.default, {
      uri: itm === null || itm === void 0 ? void 0 : itm['image-uri'],
      fixedHeight: IMAGE_DEFAULT_HEIGHT
    }) : undefined, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: styles.button,
      onPress: () => {
        onCutomQuickReply === null || onCutomQuickReply === void 0 ? void 0 : onCutomQuickReply(itm, idx);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.buttonText
    }, itm === null || itm === void 0 ? void 0 : itm.title)));
  };
  return /*#__PURE__*/_react.default.createElement(_CustomArrow.default, {
    position: restProps === null || restProps === void 0 ? void 0 : restProps.position,
    borderColor: _colors.default.blueBayoux20,
    borderWidth: 1
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.bubble
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [styles.messageText, (restProps === null || restProps === void 0 ? void 0 : restProps.position) === 'right' ? styles.messageTextRight : undefined]
  }, restProps === null || restProps === void 0 || (_restProps$currentMes2 = restProps.currentMessage) === null || _restProps$currentMes2 === void 0 ? void 0 : _restProps$currentMes2.text), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.separator
  }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.wrapContent
  }, quickReplies === null || quickReplies === void 0 ? void 0 : quickReplies.map((it, idx) => renderQuickReplyItem(it, idx)))));
};
var _default = CustomQuickReply;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  flexGrowOne: {
    flexGrow: 1
  },
  bubble: {
    maxWidth: (0, _utils.s)(251),
    justifyContent: 'flex-start',
    borderWidth: 1,
    borderColor: _colors.default.blueBayoux20,
    // alignItems: 'center',
    backgroundColor: _colors.default.white,
    borderRadius: (0, _utils.st)(5),
    paddingVertical: (0, _utils.vs)(6),
    paddingHorizontal: (0, _utils.s)(10),
    //FIXME: show empty msg
    minHeight: (0, _utils.vs)(30),
    minWidth: (0, _utils.s)(20),
    marginHorizontal: (0, _utils.s)(2)
  },
  wrapContent: {
    justifyContent: 'flex-start',
    maxWidth: (0, _utils.s)(230),
    flexDirection: 'row',
    flexWrap: 'wrap'
  },
  button: {
    backgroundColor: _colors.default.mountainMeadow,
    borderRadius: (0, _utils.st)(5),
    paddingVertical: (0, _utils.vs)(10),
    paddingHorizontal: (0, _utils.vs)(8),
    marginRight: (0, _utils.s)(10),
    marginBottom: (0, _utils.vs)(8)
  },
  image: {
    width: (0, _utils.st)(48),
    height: (0, _utils.st)(48)
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  messageText: {
    color: _colors.default.shark,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02,
    alignSelf: 'flex-start'
  },
  messageTextRight: {
    color: _colors.default.white
  },
  separator: {
    height: 1,
    width: '100%',
    backgroundColor: _colors.default.blueBayoux20,
    marginVertical: (0, _utils.vs)(4)
  },
  buttonText: {
    color: _colors.default.white,
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    lineHeight: (0, _utils.st)(16),
    letterSpacing: -0.02
  }
});
//# sourceMappingURL=CustomQuickReply.js.map