"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNativeGiftedChat = require("react-native-gifted-chat");
var _DataConverter = require("../../utils/DataConverter");
var _CustomAvatar = _interopRequireDefault(require("../ChatItem/CustomAvatar"));
var _CustomMessageImage = _interopRequireDefault(require("../ChatItem/CustomMessageImage"));
var _CustomMessage = _interopRequireDefault(require("../ChatItem/CustomMessage"));
var _reactNative = require("react-native");
var _CustomInputToolbar = _interopRequireDefault(require("../ChatItem/CustomInputToolbar/CustomInputToolbar"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const ChatList = _ref => {
  let {
    data,
    messages = [],
    onCardButtonPress,
    onQuickReplyItemPress,
    onDateTimeSelect,
    ...restProps
  } = _ref;
  const [chatData, setChatData] = (0, _react.useState)([]);
  (0, _react.useEffect)(() => {
    var _messages$concat;
    const convertedData = data === null || data === void 0 ? void 0 : data.map(it => _DataConverter.DataConverter.conversationDataToIMessage(it));
    const sortedData = (_messages$concat = messages.concat(convertedData)) === null || _messages$concat === void 0 ? void 0 : _messages$concat.sort((a, b) => {
      var _a$createdAt, _b$createdAt;
      return a.createdAt && b.createdAt && ((_a$createdAt = a.createdAt) === null || _a$createdAt === void 0 ? void 0 : _a$createdAt.valueOf()) < ((_b$createdAt = b.createdAt) === null || _b$createdAt === void 0 ? void 0 : _b$createdAt.valueOf()) ? 1 : -1;
    });
    setChatData(sortedData);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [data]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeGiftedChat.GiftedChat, _extends({
    messagesContainerStyle: styles.container,
    messages: chatData,
    renderAvatarOnTop: true,
    renderAvatar: props => {
      return /*#__PURE__*/_react.default.createElement(_CustomAvatar.default, props);
    },
    renderMessageImage: props => /*#__PURE__*/_react.default.createElement(_CustomMessageImage.default, props),
    renderBubble: props => /*#__PURE__*/_react.default.createElement(_CustomMessage.default, _extends({}, props, {
      onCardButtonPress: onCardButtonPress,
      onQuickReplyItemPress: onQuickReplyItemPress,
      onDateTimeSelect: onDateTimeSelect
    })),
    renderInputToolbar: props => /*#__PURE__*/_react.default.createElement(_CustomInputToolbar.default, props),
    shouldUpdateMessage: (currProps, nextProps) =>
    //@ts-ignore
    currProps.extraData !== nextProps.extraData
  }, restProps));
};
var _default = ChatList;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {}
});
//# sourceMappingURL=ChatList.js.map