"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _image = _interopRequireDefault(require("../../utils/theme/image"));
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _constants = require("../../utils/constants/constants");
var _reactNativeAudioRecorderPlayer = _interopRequireDefault(require("react-native-audio-recorder-player"));
var _Spacer = _interopRequireDefault(require("./Spacer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const AudioPlayer = _ref => {
  let {
    uri
  } = _ref;
  //States
  const [audioRecorderPlayer] = (0, _react.useState)(new _reactNativeAudioRecorderPlayer.default());
  const [isPlaying, setIsPlaying] = (0, _react.useState)(false);
  const [playbackMillis, setPlaybackMillis] = (0, _react.useState)(0);
  const handleStartPlay = async () => {
    console.log('handleStartPlay', uri);
    try {
      const msg = await audioRecorderPlayer.startPlayer(uri);
      setIsPlaying(true);

      //? Default path
      // const msg = await this.audioRecorderPlayer.startPlayer();
      const volume = await audioRecorderPlayer.setVolume(1.0);
      console.log(`path: ${msg}`, `volume: ${volume}`);
      audioRecorderPlayer.addPlayBackListener(e => {
        // console.log('playBackListener', e);
        setPlaybackMillis(e.currentPosition);
        if (e.duration === e.currentPosition) {
          handleStopPlay();
        }
      });
    } catch (err) {
      console.log('startPlayer error', err);
    }
  };
  const handleStopPlay = async () => {
    console.log('onStopPlay');
    await audioRecorderPlayer.stopPlayer();
    audioRecorderPlayer.removePlayBackListener();
    setIsPlaying(false);
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.rowContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    onPress: () => {
      if (isPlaying) {
        handleStopPlay();
      } else {
        handleStartPlay();
      }
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: isPlaying ? _image.default.ic_stop_play : _image.default.ic_player,
    resizeMode: 'contain',
    style: styles.imageRecordButton
  })), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    width: 10
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: _image.default.ic_record_line,
    style: styles.recordLineImage
  })), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    height: 6
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.text
  }, _utils.DateTimeHelper.msToHMS(playbackMillis)));
};
var _default = AudioPlayer;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {
    width: _utils.screenWidth * 3 / 4,
    paddingVertical: (0, _utils.vs)(7),
    paddingLeft: (0, _utils.vs)(10),
    paddingRight: (0, _utils.vs)(15)
  },
  rowContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  text: {
    color: _colors.default.nobel,
    fontSize: (0, _utils.st)(12),
    fontWeight: _constants.isIOS ? '500' : 'normal',
    alignSelf: 'flex-start',
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  recordLineImage: {
    flex: 1,
    height: (0, _utils.vs)(24)
  },
  imageRecordButton: {
    width: (0, _utils.st)(24),
    height: (0, _utils.st)(24)
  }
});
//# sourceMappingURL=AudioPlayer.js.map