"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
var _utils = require("../../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint-disable react-native/no-inline-styles */

const CustomArrow = _ref => {
  let {
    children,
    position,
    borderColor,
    borderWidth = 0,
    ...restProps
  } = _ref;
  const sideStyle = position === 'right' ? styles.rightTriangle : styles.leftTriangle;
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, restProps, children, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.triangle, sideStyle, {
      borderBottomColor: borderColor,
      transform: [{
        scale: (10 + borderWidth * 2) / 10
      }, {
        rotate: '-90deg'
      }],
      marginLeft: position === 'left' ? -borderWidth * 2 - 1 : 0,
      marginRight: position === 'right' ? -borderWidth * 2 - 1 : 0,
      left: position === 'left' && sideStyle !== null && sideStyle !== void 0 && sideStyle.left ? (sideStyle === null || sideStyle === void 0 ? void 0 : sideStyle.left) - borderWidth : undefined,
      right: position === 'right' && sideStyle !== null && sideStyle !== void 0 && sideStyle.right ? (sideStyle === null || sideStyle === void 0 ? void 0 : sideStyle.right) - borderWidth : undefined
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.triangle, sideStyle]
  }));
};
var _default = CustomArrow;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  triangle: {
    position: 'absolute',
    top: (0, _utils.vs)(5),
    width: 0,
    height: 0,
    backgroundColor: 'transparent',
    borderStyle: 'solid',
    borderTopWidth: (0, _utils.s)(10),
    borderBottomWidth: (0, _utils.s)(10),
    borderTopColor: 'transparent',
    borderRightColor: 'transparent',
    borderLeftColor: 'transparent',
    zIndex: 10
  },
  leftTriangle: {
    borderBottomColor: _colors.default.white,
    left: -(0, _utils.s)(10),
    right: undefined,
    transform: [{
      rotate: '-90deg'
    }],
    borderRightWidth: 0,
    borderLeftWidth: (0, _utils.s)(10)
  },
  rightTriangle: {
    borderBottomColor: _colors.default.blueBayoux,
    left: undefined,
    right: -(0, _utils.s)(10),
    transform: [{
      rotate: '90deg'
    }],
    borderRightWidth: (0, _utils.s)(10),
    borderLeftWidth: 0
  }
});
//# sourceMappingURL=CustomArrow.js.map