"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _colors = _interopRequireDefault(require("../../../utils/theme/colors"));
var _utils = require("../../../utils");
var _Spacer = _interopRequireDefault(require("../Spacer"));
var _constants = require("../../../utils/constants/constants");
var _reactNativeCalendars = require("react-native-calendars");
var _moment = _interopRequireDefault(require("moment"));
var _CustomTimeDropdown = _interopRequireDefault(require("./components/CustomTimeDropdown"));
var _i18n = require("../../../i18n");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const CustomDateTimePicker = _ref => {
  let {
    pickerProps,
    onConfirm,
    ...restProps
  } = _ref;
  const todayMoment = (0, _moment.default)();
  const minDateMoment = _utils.DateTimeHelper.toMoment(pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['min-date']);
  const maxDateMoment = _utils.DateTimeHelper.toMoment(pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['max-date']);
  //States
  const [date, setDate] = (0, _react.useState)();
  // pickerProps?.type === 'date_range' ||
  //   (pickerProps?.['date-limit-type'] === 'future_only' &&
  //   !pickerProps?.['include-current-date']) ||
  //     (pickerProps?.['date-limit-type'] === 'limited' &&
  //     !DateTimeHelper.isBetween(new Date(), minDateMoment?.toDate(), maxDateMoment?.toDate()))
  //   ? undefined
  //   : new Date()
  const [endDate, setEndDate] = (0, _react.useState)();
  const [time, setTime] = (0, _react.useState)((0, _moment.default)().set({
    hour: 1,
    minute: 0,
    second: 0,
    millisecond: 0
  }).toDate());
  const [dateError, setDateError] = (0, _react.useState)('');
  const [timeError, setTimeError] = (0, _react.useState)('');

  //Variables that uses multiple times
  const showPickDate = ['date', 'datetime', 'date_range'].includes(pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps.type);
  const showPickTime = ['datetime', 'time'].includes(pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps.type);
  const isDateRange = (pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps.type) === 'date_range';
  const timeParts = _utils.DateTimeHelper.getHourByPeriod(time);
  const locale = pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps.language;

  //Effects
  (0, _react.useEffect)(() => {
    //Update minutes to nearest minutes in selection
    time.setMinutes((minutes === null || minutes === void 0 ? void 0 : minutes.find(it => it >= (timeParts === null || timeParts === void 0 ? void 0 : timeParts.minutes))) ?? 0);
    setTime(new Date(time));
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  //Functions
  const handleDateSelect = day => {
    const mDay = (0, _moment.default)(day === null || day === void 0 ? void 0 : day.timestamp);
    const mStart = date ? (0, _moment.default)(date) : undefined;
    const mEnd = endDate ? (0, _moment.default)(endDate) : undefined;
    setDateError('');

    //Case 1: Pick 1 date only
    if (!isDateRange) {
      if (!date || !(mDay !== null && mDay !== void 0 && mDay.isSame(mStart))) {
        setDate(new Date(day.timestamp));
      } else {
        setDate(undefined);
      }
      return;
    }
    // Case 2: Pick date range
    if (!date) {
      setDate(mDay.toDate());
    } else if (!endDate) {
      if (mDay.isSameOrBefore(mStart, 'd')) {
        setEndDate(mStart === null || mStart === void 0 ? void 0 : mStart.toDate());
        setDate(mDay.toDate());
      } else {
        setEndDate(mDay.toDate());
      }
    } else {
      if (mDay.isSame(mStart, 'd')) {
        setDate(undefined);
        setEndDate(undefined);
      } else if (mDay.isSame(mEnd, 'd')) {
        setDate(mDay.toDate());
        setEndDate(undefined);
      } else if (mDay.isAfter(mStart, 'd')) {
        setEndDate(mDay.toDate());
      } else {
        setDate(mDay.toDate());
      }
    }
  };
  const handleConfirm = () => {
    const finalDate = date ? (0, _moment.default)(date) : (0, _moment.default)();
    if (isDateRange && (!date || !endDate)) {
      setDateError((0, _i18n.translate)('please_select_a_valid_date_range', undefined, locale));
      return;
    } else if (showPickDate && !date) {
      setDateError((0, _i18n.translate)('please_select_a_date', undefined, locale));
      return;
    } else if (showPickTime && !time) {
      setDateError((0, _i18n.translate)('please_select_a_valid_time', undefined, locale));
      return;
    }
    if (time) {
      finalDate.hour(time.getHours());
      finalDate.minute(time.getMinutes());
      finalDate.second(time.getSeconds());
    }
    onConfirm === null || onConfirm === void 0 ? void 0 : onConfirm(finalDate.toDate(), endDate);
  };
  const renderCommonTextGroup = function (label) {
    let content = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    let customPrefixContent = arguments.length > 2 ? arguments[2] : undefined;
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.columnContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.label
    }, label), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.row
    }, customPrefixContent, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.description
    }, content)));
  };
  const renderSelectedDate = () => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, showPickDate ? renderCommonTextGroup((0, _i18n.translate)(isDateRange ? 'start_date' : 'selected_date', undefined, locale), date ? _utils.DateTimeHelper.formatMindXDatetime(date, undefined, pickerProps, {
      isDateOnly: true
    }) ?? '-' : '-') : undefined, showPickDate ? /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      width: 10
    }) : undefined, showPickTime ? renderCommonTextGroup((0, _i18n.translate)('selected_time', undefined, locale), time ? (0, _i18n.translate)(`time_${_utils.DateTimeHelper.formatDate(time, 'A') ?? ''}`, {
      time: _utils.DateTimeHelper.formatDate(time, 'hh:mm ') ?? ''
    }, locale) : '_') : isDateRange ? renderCommonTextGroup((0, _i18n.translate)('end_date', undefined, locale), endDate ? _utils.DateTimeHelper.formatMindXDatetime(endDate, undefined, pickerProps, {
      isDateOnly: true
    }) ?? '-' : '-') : undefined);
  };
  const renderCalendar = () => {
    //Language
    const calendarLang = locale ? locale : 'en';
    if (calendarLang) {
      _reactNativeCalendars.LocaleConfig.locales[calendarLang] = (0, _i18n.translate)('calendar_format', undefined, calendarLang);
      _reactNativeCalendars.LocaleConfig.defaultLocale = calendarLang;
    }
    //Start/end dates
    const mStart = date ? (0, _moment.default)(date) : undefined;
    const mEnd = endDate ? (0, _moment.default)(endDate) : undefined;

    //Date selection limit
    const mToday = (0, _moment.default)();
    const minDateStr = (pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['date-limit-type']) === 'future_only' ? _utils.DateTimeHelper.formatDate(pickerProps !== null && pickerProps !== void 0 && pickerProps['include-current-date'] ? mToday.toDate() : mToday.add(1, 'd').toDate(), 'YYYY-MM-DD') : (pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['date-limit-type']) === 'limited' && pickerProps !== null && pickerProps !== void 0 && pickerProps['min-date'] ? minDateMoment === null || minDateMoment === void 0 ? void 0 : minDateMoment.format('YYYY-MM-DD') : undefined;
    const maxDateStr = (pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['date-limit-type']) === 'limited' && pickerProps !== null && pickerProps !== void 0 && pickerProps['max-date'] ? maxDateMoment === null || maxDateMoment === void 0 ? void 0 : maxDateMoment.format('YYYY-MM-DD') : undefined;

    //Marking renders
    var markedDates = {};
    if (mStart) {
      if (isDateRange) {
        markedDates[mStart.format('YYYY-MM-DD')] = {
          startingDay: false,
          endingDay: false,
          // !mEnd || mStart?.isSame(mEnd, 'd'),
          selected: true,
          disableTouchEvent: false,
          color: _colors.default.earlyDawn,
          textColor: _colors.default.white,
          customContainerStyle: {
            borderRadius: (0, _utils.st)(20),
            width: (0, _utils.st)(36),
            height: (0, _utils.st)(36),
            backgroundColor: _colors.default.butterCup,
            marginRight: (0, _utils.st)(_constants.isIOS ? 4 : 6.8)
          }
        };
      } else {
        markedDates[mStart.format('YYYY-MM-DD')] = {
          selected: true,
          disableTouchEvent: false,
          selectedColor: _colors.default.butterCup,
          selectedTextColor: _colors.default.white,
          startingDay: true,
          endingDay: true,
          color: _colors.default.butterCup,
          textColor: _colors.default.white
        };
      }
    }
    if (mEnd) {
      markedDates[mEnd.format('YYYY-MM-DD')] = {
        startingDay: false,
        // mStart?.isSame(mEnd, 'd'),
        endingDay: false,
        selected: true,
        disableTouchEvent: false,
        color: _colors.default.earlyDawn,
        textColor: _colors.default.white,
        customContainerStyle: {
          borderRadius: (0, _utils.st)(20),
          width: (0, _utils.st)(36),
          height: (0, _utils.st)(36),
          backgroundColor: _colors.default.butterCup
        }
      };
    }
    for (var m = (0, _moment.default)(mStart).add(1, 'd'); mEnd && m !== null && m !== void 0 && m.isBefore(mEnd, 'd'); m === null || m === void 0 ? void 0 : m.add(1, 'd')) {
      markedDates[m.format('YYYY-MM-DD')] = {
        color: _colors.default.earlyDawn,
        startingDay: false,
        endingDay: false
      };
    }
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.separator
    }), /*#__PURE__*/_react.default.createElement(_reactNativeCalendars.Calendar, {
      key: `calendar-${locale}`,
      theme: {
        'arrowColor': _colors.default.shark,
        'textMonthFontWeight': 'bold',
        'textMonthFontSize': (0, _utils.st)(12),
        'monthTextColor': _colors.default.shark,
        'textDayHeaderFontWeight': 'bold',
        'textDayHeaderFontSize': (0, _utils.st)(12),
        'dayTextColor': _colors.default.black,
        'todayTextColor': _colors.default.black,
        //FIXME: this will be overrided by below
        'todayButtonFontWeight': 'bold',
        //@ts-ignore
        'stylesheet.day.basic': {
          todayText: {
            fontWeight: 'bold',
            color: _colors.default.black
          }
        },
        //@ts-ignore
        'stylesheet.day.period': {
          todayText: {
            fontWeight: 'bold',
            color: _colors.default.black
          }
        }
      },
      initialDate: date ? _utils.DateTimeHelper.formatDate(date, 'YYYY-MM-DD') : undefined,
      onDayPress: day => {
        handleDateSelect(day);
      },
      monthFormat: locale === 'en' ? 'yyyy.M' : undefined,
      markedDates: markedDates,
      markingType: isDateRange ? 'period' : 'dot',
      minDate: minDateStr,
      maxDate: maxDateStr,
      hideArrows: (minDateMoment === null || minDateMoment === void 0 ? void 0 : minDateMoment.isSame(todayMoment, 'month')) && (maxDateMoment === null || maxDateMoment === void 0 ? void 0 : maxDateMoment.isSame(todayMoment, 'month'))
    }), dateError ? /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.errorText
    }, dateError) : undefined);
  };
  const renderTimePicker = () => {
    const isPM = (timeParts === null || timeParts === void 0 ? void 0 : timeParts.period) === 'PM';
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.separator
    }), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.subTitle
    }, (0, _i18n.translate)('time', undefined, locale)), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_CustomTimeDropdown.default, {
      data: hours,
      locale: locale,
      defaultValue: timeParts === null || timeParts === void 0 ? void 0 : timeParts.hours,
      selectedRowStyle: styles.selectedRow,
      onSelect: (selectedItem, _index) => {
        setTimeError('');
        time.setHours(isPM && selectedItem !== 12 ? selectedItem + 12 : !isPM && selectedItem === 12 ? 0 : selectedItem);
        setTime(new Date(time));
      }
    }), /*#__PURE__*/_react.default.createElement(_CustomTimeDropdown.default, {
      data: minutes,
      locale: locale,
      defaultValue: timeParts === null || timeParts === void 0 ? void 0 : timeParts.minutes,
      selectedRowStyle: styles.selectedRow,
      onSelect: (selectedItem, _index) => {
        setTimeError('');
        time.setMinutes(selectedItem);
        setTime(new Date(time));
      }
    }), /*#__PURE__*/_react.default.createElement(_CustomTimeDropdown.default, {
      data: timePeriod,
      locale: locale,
      defaultValue: timeParts === null || timeParts === void 0 ? void 0 : timeParts.period,
      onSelect: (selectedItem, _index) => {
        setTimeError('');
        time === null || time === void 0 ? void 0 : time.setHours(selectedItem === 'PM' && (timeParts === null || timeParts === void 0 ? void 0 : timeParts.hours) !== 12 ? (timeParts === null || timeParts === void 0 ? void 0 : timeParts.hours) + 12 : selectedItem === 'AM' && (timeParts === null || timeParts === void 0 ? void 0 : timeParts.hours) === 12 ? 0 : timeParts === null || timeParts === void 0 ? void 0 : timeParts.hours);
        setTime(new Date(time));
      }
    })), timeError ? /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.errorText
    }, timeError) : undefined);
  };
  const renderButton = () => {
    // || showPickDate && !date || showPickTime && !time //=> never happen since `date` and `time` have initial value
    return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity
    // disabled={isDisabled}
    , {
      style: [styles.button],
      onPress: () => {
        handleConfirm === null || handleConfirm === void 0 ? void 0 : handleConfirm();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.buttonText
    }, (pickerProps === null || pickerProps === void 0 ? void 0 : pickerProps['button-label']) ?? 'Confirm'));
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, restProps, renderSelectedDate(), showPickDate ? renderCalendar() : undefined, showPickTime ? renderTimePicker() : undefined, /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    height: 10
  }), renderButton(), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
    height: 16
  }));
};
var _default = CustomDateTimePicker;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  rowContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  row: {
    flexDirection: 'row',
    alignItems: 'center'
  },
  columnContainer: {
    width: '50%',
    flexDirection: 'column',
    justifyContent: 'flex-start',
    alignItems: 'flex-start',
    paddingBottom: (0, _utils.s)(6)
  },
  label: {
    fontWeight: _constants.isIOS ? '700' : 'bold',
    fontSize: (0, _utils.s)(12),
    color: _colors.default.edward,
    letterSpacing: -0.02,
    textAlign: 'left',
    textAlignVertical: 'center'
  },
  subTitle: {
    fontWeight: _constants.isIOS ? '600' : 'bold',
    fontSize: (0, _utils.st)(12),
    color: _colors.default.shark,
    letterSpacing: -0.02,
    alignSelf: 'flex-start',
    textAlign: 'center',
    textAlignVertical: 'center',
    marginVertical: (0, _utils.vs)(8)
  },
  description: {
    fontWeight: _constants.isIOS ? '700' : 'bold',
    fontSize: (0, _utils.st)(14),
    color: _colors.default.shark,
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  errorText: {
    fontWeight: _constants.isIOS ? '500' : 'normal',
    fontSize: (0, _utils.st)(14),
    color: _colors.default.redOrange,
    letterSpacing: -0.02,
    textAlign: 'left',
    textAlignVertical: 'center'
  },
  separator: {
    height: 1,
    width: '100%',
    backgroundColor: _colors.default.blueBayoux20,
    marginVertical: (0, _utils.vs)(4)
  },
  selectedRow: {
    backgroundColor: _colors.default.earlyDawn
  },
  button: {
    // flex: 1,
    minWidth: (0, _utils.s)(120),
    borderRadius: (0, _utils.st)(2),
    padding: (0, _utils.st)(10),
    backgroundColor: _colors.default.mountainMeadow,
    alignSelf: 'center',
    justifyContent: 'center',
    alignItems: 'center'
  },
  buttonText: {
    fontSize: (0, _utils.st)(16),
    color: _colors.default.white,
    textAlign: 'center',
    textAlignVertical: 'center'
  }
});
const hours = [...Array(12).keys()].map(it => it += 1); // start from 1 to 12
const minutes = [...Array(60).keys()].filter(it => it % 5 === 0);
const timePeriod = ['AM', 'PM'];
//# sourceMappingURL=CustomDateTimePicker.js.map