"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../../../utils");
var _reactNativeSelectDropdown = _interopRequireDefault(require("react-native-select-dropdown"));
var _colors = _interopRequireDefault(require("../../../../utils/theme/colors"));
var _constants = require("../../../../utils/constants/constants");
var _image = _interopRequireDefault(require("../../../../utils/theme/image"));
var _i18n = require("../../../../i18n");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const CustomTimeDropdown = _ref => {
  let {
    buttonStyle,
    locale,
    ...restProps
  } = _ref;
  const renderTextLabel = (item, _index) => {
    const valStr = typeof item === 'number' && item < 10 ? `0${item}` : item === null || item === void 0 ? void 0 : item.toString();
    return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.text
    }, (0, _i18n.translate)(valStr, undefined, locale));
  };
  const renderTextItem = (item, index) => {
    const valStr = typeof item === 'number' && item < 10 ? `0${item}` : item === null || item === void 0 ? void 0 : item.toString();
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.textItem,
      key: `textItem-${index}`
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: [styles.text, styles.opionText]
    }, (0, _i18n.translate)(valStr, undefined, locale)));
  };
  const renderSelectedContent = (selectedItem, index) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, renderTextLabel(selectedItem, index), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_arrow_down,
      resizeMode: 'contain',
      style: styles.arrowDown
    }));
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_reactNativeSelectDropdown.default, _extends({}, restProps, {
    buttonStyle: [styles.button, buttonStyle],
    buttonTextAfterSelection: (selectedItem, _index) => {
      return selectedItem;
    },
    rowTextForSelection: (item, _index) => {
      return item;
    },
    renderCustomizedButtonChild: (selectedItem, index) => renderSelectedContent(selectedItem, index),
    renderCustomizedRowChild: (item, index) => renderTextItem(item, index)
  })));
};
var _default = CustomTimeDropdown;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  container: {},
  rowContainer: {
    flex: 1,
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    paddingHorizontal: (0, _utils.s)(6)
  },
  button: {
    flexGrow: 1,
    height: (0, _utils.s)(30),
    width: (0, _utils.s)(68),
    paddingVertical: (0, _utils.vs)(5),
    backgroundColor: _colors.default.porcelian,
    borderWidth: (0, _utils.st)(1),
    borderColor: _colors.default.cornflowerBlue,
    flexDirection: 'row',
    alignItems: 'center',
    paddingHorizontal: (0, _utils.s)(6)
  },
  textItem: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    paddingHorizontal: (0, _utils.s)(6)
  },
  text: {
    fontSize: (0, _utils.s)(12),
    color: _colors.default.black,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  opionText: {
    flex: 1,
    fontWeight: _constants.isIOS ? '700' : 'bold',
    alignSelf: 'center'
  },
  arrowDown: {
    width: (0, _utils.st)(10),
    height: (0, _utils.st)(10)
  }
});
//# sourceMappingURL=CustomTimeDropdown.js.map