"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _reactNativeLightboxV = _interopRequireDefault(require("react-native-lightbox-v2"));
var _colors = _interopRequireDefault(require("../../utils/theme/colors"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const IMAGE_DEFAULT_WIDTH = (0, _utils.s)(189);
const IMAGE_DEFAULT_HEIGHT = (0, _utils.vs)(112);
const CustomImage = _ref => {
  let {
    uri,
    fixedWidth,
    fixedHeight
  } = _ref;
  const defaultWidth = fixedWidth ? fixedWidth : IMAGE_DEFAULT_WIDTH;
  const defaultHeight = fixedHeight ? fixedHeight : IMAGE_DEFAULT_HEIGHT;
  //States
  const [imageWidth, setImageWidth] = (0, _react.useState)(0);
  const [imageheight, setImageHeight] = (0, _react.useState)(0);
  const [isImageFetching, setIsImageFetching] = (0, _react.useState)();

  //Vars
  const calculatedHeight = imageheight * defaultWidth / (imageWidth ? imageWidth : 1);
  const calculatedWidth = imageWidth * defaultHeight / (imageheight ? imageheight : 1);
  //Effects
  (0, _react.useEffect)(() => {
    getSize();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [uri]);
  const getSize = async () => {
    if (uri) {
      _reactNative.Image.getSize(uri, (width, height) => {
        // console.log(width, height);
        setImageWidth(isNaN(width) ? defaultWidth : width);
        setImageHeight(isNaN(height) ? defaultHeight : height);
      }, e => {
        console.log(e);
        setImageWidth(defaultWidth);
        setImageHeight(defaultHeight);
      });
    }
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNativeLightboxV.default, {
    activeProps: {
      style: styles.imageActive
    }
    // {...lightboxProps}
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: {
      uri: uri
    },
    style: [styles.image, {
      width: fixedWidth ? defaultWidth : calculatedWidth,
      height: fixedHeight ? defaultHeight : calculatedHeight
    }],
    onLoadStart: () => {
      if (isImageFetching !== false) {
        // false mean it already loaded
        setIsImageFetching(true);
      }
    },
    onLoadEnd: () => {
      setIsImageFetching(false);
    }
  })), !imageWidth || !imageheight || isImageFetching ? /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
    style: styles.activityIndicator,
    color: _colors.default.mountainMeadow
  }) : undefined);
};
var _default = CustomImage;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  image: {
    // width: s(214),
    height: (0, _utils.vs)(112),
    borderRadius: (0, _utils.st)(5),
    margin: (0, _utils.st)(3),
    // resizeMode: 'cover',
    alignSelf: 'center'
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  activityIndicator: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0,
    padding: (0, _utils.st)(10)
  }
});
//# sourceMappingURL=CustomImage.js.map