"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
var _constants = require("../../../utils/constants/constants");
class RecorderPlayerResponsiveManager {
  register(_instance) {
    if (!this._currentPopup) {
      this._currentPopup = _instance;
    }
  }
  unregister(_instance) {
    if (!!this._currentPopup && this._currentPopup === _instance) {
      this._currentPopup = undefined;
    }
  }
  getCurrent() {
    return this._currentPopup;
  }
  togglePopup() {
    if (this !== null && this !== void 0 && this._currentPopup) {
      var _this$_currentPopup, _this$_currentPopup$t;
      (_this$_currentPopup = this._currentPopup) === null || _this$_currentPopup === void 0 || (_this$_currentPopup$t = _this$_currentPopup.togglePopup) === null || _this$_currentPopup$t === void 0 ? void 0 : _this$_currentPopup$t.call(_this$_currentPopup);
    }
  }
  async showPopup(props) {
    if (!(await this.checkPermissions())) {
      return;
    }
    if (this !== null && this !== void 0 && this._currentPopup) {
      var _this$_currentPopup2, _this$_currentPopup2$;
      (_this$_currentPopup2 = this._currentPopup) === null || _this$_currentPopup2 === void 0 || (_this$_currentPopup2$ = _this$_currentPopup2.showPopup) === null || _this$_currentPopup2$ === void 0 ? void 0 : _this$_currentPopup2$.call(_this$_currentPopup2, props);
    }
  }
  hidePopup() {
    if (this !== null && this !== void 0 && this._currentPopup) {
      var _this$_currentPopup3, _this$_currentPopup3$;
      (_this$_currentPopup3 = this._currentPopup) === null || _this$_currentPopup3 === void 0 || (_this$_currentPopup3$ = _this$_currentPopup3.hidePopup) === null || _this$_currentPopup3$ === void 0 ? void 0 : _this$_currentPopup3$.call(_this$_currentPopup3);
    }
  }
  async showPopupAsync(props) {
    if (this !== null && this !== void 0 && this._currentPopup) {
      return await new Promise(async (resolve, reject) => {
        var _this$_currentPopup4, _this$_currentPopup4$;
        if (!(await this.checkPermissions())) {
          return reject('Permissions not granted');
        }
        (_this$_currentPopup4 = this._currentPopup) === null || _this$_currentPopup4 === void 0 || (_this$_currentPopup4$ = _this$_currentPopup4.showPopup) === null || _this$_currentPopup4$ === void 0 ? void 0 : _this$_currentPopup4$.call(_this$_currentPopup4, {
          ...props,
          onClose: result => {
            var _props$onClose;
            props === null || props === void 0 || (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props, result);
            if (result) {
              return resolve(result);
            } else {
              return reject('Empty data');
            }
          }
        });
      });
    }
    return Promise.reject('Popup not initialized');
  }

  //Private functions
  /**
   * Check Permission for start record
   * @returns permission result
   */
  async checkPermissions() {
    // Prepare android permissions
    if (_constants.isAndroid) {
      try {
        const grants = await _reactNative.PermissionsAndroid.requestMultiple([_reactNative.PermissionsAndroid.PERMISSIONS.WRITE_EXTERNAL_STORAGE, _reactNative.PermissionsAndroid.PERMISSIONS.READ_EXTERNAL_STORAGE, _reactNative.PermissionsAndroid.PERMISSIONS.RECORD_AUDIO]);
        // console.log('Record permissions:', grants);

        if ((grants['android.permission.WRITE_EXTERNAL_STORAGE'] === _reactNative.PermissionsAndroid.RESULTS.GRANTED && grants['android.permission.READ_EXTERNAL_STORAGE'] === _reactNative.PermissionsAndroid.RESULTS.GRANTED || _constants.releaseVersion >= '13') && grants['android.permission.RECORD_AUDIO'] === _reactNative.PermissionsAndroid.RESULTS.GRANTED) {
          // console.log('permissions granted');
          return true;
        } else {
          // console.log('All required permissions not granted');
          return false;
        }
      } catch (err) {
        console.warn(err);
        return false;
      }
    }
    return true;
  }
}
var _default = new RecorderPlayerResponsiveManager();
exports.default = _default;
//# sourceMappingURL=RecorderPlayerResponsiveManager.js.map