"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _scaler = require("../../../utils/scaler");
var _RecorderPlayerResponsiveManager = _interopRequireDefault(require("./RecorderPlayerResponsiveManager"));
var _colors = _interopRequireDefault(require("../../../utils/theme/colors"));
var _constants = require("../../../utils/constants/constants");
var _image = _interopRequireDefault(require("../../../utils/theme/image"));
var _Spacer = _interopRequireDefault(require("../Spacer"));
var _reactNativeAudioRecorderPlayer = _interopRequireWildcard(require("react-native-audio-recorder-player"));
var _utils = require("../../../utils");
var _reactNativeBlobUtil = _interopRequireDefault(require("react-native-blob-util"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const RecorderPlayerResponsivePopup = (_props, ref) => {
  var _RNBlobUtil$fs;
  //States
  const [audioRecorderPlayer] = (0, _react.useState)(new _reactNativeAudioRecorderPlayer.default());
  const [isVisible, setIsVisible] = (0, _react.useState)(false);
  const [showProps, setShowProps] = (0, _react.useState)();
  const [recordMillis, setRecordMillis] = (0, _react.useState)(0);
  const {
    // type,
    // initialUrl,
    position,
    positionAt,
    onClose,
    extraButtonUI,
    onExtraButtonPress
  } = showProps ?? {};
  // variables that use multiple times
  audioRecorderPlayer.setSubscriptionDuration(0.1);
  var path = _reactNative.Platform.select({
    ios: 'sound.m4a',
    android: `${_reactNativeBlobUtil.default === null || _reactNativeBlobUtil.default === void 0 || (_RNBlobUtil$fs = _reactNativeBlobUtil.default.fs) === null || _RNBlobUtil$fs === void 0 || (_RNBlobUtil$fs = _RNBlobUtil$fs.dirs) === null || _RNBlobUtil$fs === void 0 ? void 0 : _RNBlobUtil$fs.CacheDir}/sound.mp3`
  });
  (0, _react.useImperativeHandle)(ref, () => ({
    showPopup,
    togglePopup,
    hidePopup
  }));
  (0, _react.useEffect)(() => {
    const passData = {
      showPopup,
      togglePopup,
      hidePopup
    };
    _RecorderPlayerResponsiveManager.default.register(passData);
    return function cleanUp() {
      _RecorderPlayerResponsiveManager.default.unregister(passData);
    };
  });
  const togglePopup = () => {
    setIsVisible(prev => !prev);
  };
  const showPopup = showPopupProps => {
    setIsVisible(true);
    setShowProps(showPopupProps);
    if ((showPopupProps === null || showPopupProps === void 0 ? void 0 : showPopupProps.type) === 'record') {
      handleStartRecord();
    }
  };
  const hidePopup = () => {
    setIsVisible(false);
    return;
  };
  const selectPosition = () => {
    if (positionAt) {
      return {
        position: 'absolute',
        ...positionAt
      };
    }
    switch (position) {
      case 'topCenter':
        {
          return styles.absoluteTopCenter;
        }
      case 'bottomCenter':
        {
          return styles.absoluteBottomCenter;
        }
      case 'center':
      default:
        {
          return styles.absoluteCenter;
        }
    }
  };
  const handleStartRecord = async () => {
    const audioSet = {
      AudioEncoderAndroid: _reactNativeAudioRecorderPlayer.AudioEncoderAndroidType.AAC,
      AudioSourceAndroid: _reactNativeAudioRecorderPlayer.AudioSourceAndroidType.MIC,
      AVEncoderAudioQualityKeyIOS: _reactNativeAudioRecorderPlayer.AVEncoderAudioQualityIOSType.high,
      AVNumberOfChannelsKeyIOS: 2,
      AVFormatIDKeyIOS: _reactNativeAudioRecorderPlayer.AVEncodingOption.aac,
      OutputFormatAndroid: _reactNativeAudioRecorderPlayer.OutputFormatAndroidType.AAC_ADTS
    };
    audioRecorderPlayer.addRecordBackListener(e => {
      // console.log('record-back', e);
      setRecordMillis(e === null || e === void 0 ? void 0 : e.currentPosition);
    });
    const uri = await (audioRecorderPlayer === null || audioRecorderPlayer === void 0 ? void 0 : audioRecorderPlayer.startRecorder(path, audioSet));
    console.log(`uri: ${uri}`);
  };
  const handleStopRecord = async isClose => {
    audioRecorderPlayer.removeRecordBackListener();
    const result = await audioRecorderPlayer.stopRecorder();
    setRecordMillis(0);
    console.log(result);

    //Close popup
    hidePopup();
    onClose === null || onClose === void 0 ? void 0 : onClose(isClose ? undefined : result);
  };
  const renderContent = () => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: [styles.container, selectPosition()]
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.text
    }, _utils.DateTimeHelper.msToHMS(recordMillis)), /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_record_line,
      style: styles.recordLineImage
    })), /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      height: 16
    }), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.rowContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        handleStopRecord(true);
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    })), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        handleStopRecord();
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: _image.default.ic_stop_play,
      resizeMode: 'contain',
      style: styles.imageRecordButton
    })), extraButtonUI ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: () => {
        onExtraButtonPress === null || onExtraButtonPress === void 0 ? void 0 : onExtraButtonPress();
      }
    }, extraButtonUI) : /*#__PURE__*/_react.default.createElement(_Spacer.default, {
      width: 20
    })));
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, isVisible ? renderContent() : null);
};
const styles = _reactNative.StyleSheet.create({
  container: {
    padding: (0, _scaler.st)(16),
    backgroundColor: _colors.default.white,
    borderRadius: (0, _scaler.st)(5),
    marginHorizontal: (0, _scaler.st)(6)
  },
  absoluteCenter: {
    position: 'absolute',
    top: '40%',
    alignSelf: 'center'
  },
  absoluteTopCenter: {
    position: 'absolute',
    top: (0, _scaler.vs)(24),
    alignSelf: 'center'
  },
  absoluteBottomCenter: {
    position: 'absolute',
    bottom: (0, _scaler.vs)(24),
    alignSelf: 'center'
  },
  rowContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  text: {
    color: _colors.default.black,
    fontSize: (0, _scaler.st)(12),
    fontWeight: _constants.isIOS ? '500' : 'normal',
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  recordLineImage: {
    flex: 1,
    height: (0, _scaler.vs)(24)
  },
  imageTrashBtn: {
    width: (0, _scaler.st)(20),
    height: (0, _scaler.st)(20)
  },
  imageRecordButton: {
    width: (0, _scaler.st)(32),
    height: (0, _scaler.st)(32)
  }
});
var _default = /*#__PURE__*/(0, _react.forwardRef)(RecorderPlayerResponsivePopup);
exports.default = _default;
//# sourceMappingURL=RecorderPlayerResponsiveView.js.map