"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _utils = require("../../utils");
var _reactNativeVideo = _interopRequireDefault(require("react-native-video"));
var _SvgPlayButton = _interopRequireDefault(require("../../assets/png/ReactSvgs/SvgPlayButton"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const VideoPlayer = _ref => {
  let {
    uri,
    ...restProps
  } = _ref;
  //State
  const [pause, setPaused] = (0, _react.useState)(true);
  //Refs
  const videoRef = (0, _react.useRef)(null);
  const renderVideo = (0, _react.useMemo)(() => {
    return (
      /*#__PURE__*/
      // @ts-ignore
      _react.default.createElement(_reactNativeVideo.default, _extends({}, restProps, {
        ref: videoRef,
        source: {
          uri
        },
        resizeMode: 'contain',
        style: [styles.video, restProps === null || restProps === void 0 ? void 0 : restProps.style],
        onLoad: _videoData => {
          var _videoRef$current;
          videoRef === null || videoRef === void 0 || (_videoRef$current = videoRef.current) === null || _videoRef$current === void 0 ? void 0 : _videoRef$current.seek(0);
          // setPaused(true);
        },

        paused: pause,
        onLoadStart: () => {}
        // controls={true}
      }))
    );
  }, [uri, restProps, pause]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableHighlight, {
    onPress: () => {
      setPaused(prev => !prev);
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.videoWrapper
  }, renderVideo, pause ? /*#__PURE__*/_react.default.createElement(_SvgPlayButton.default, {
    style: styles.absoluteCenter
  }) : undefined));
};
var _default = VideoPlayer;
exports.default = _default;
const styles = _reactNative.StyleSheet.create({
  videoWrapper: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center'
  },
  video: {
    width: _utils.screenWidth * 3 / 4,
    height: _utils.screenWidth * 3 / 4 * 9 / 16,
    justifyContent: 'center',
    alignItems: 'center'
  },
  absoluteCenter: {
    position: 'absolute',
    alignSelf: 'center'
  }
});
//# sourceMappingURL=VideoPlayer.js.map