"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExpressionApi = void 0;
var _axios = _interopRequireDefault(require("axios"));
var _ErrorHandler = _interopRequireDefault(require("../../utils/errors/ErrorHandler"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//@ts-nocheck

class ExpressionApi {
  /**
   * Create a new Expression Api object
   * @param host API host
   */
  constructor(host) {
    this.host = host;
    this.axiosInstance = _axios.default.create({
      baseURL: this.host,
      headers: {
        'Access-Control-Allow-Headers': '*'
      }
    });
  }
  getGateway = async (DEVELOPER_ID, SCOPE_ID, headers, params) => {
    try {
      var _response$headers, _response$data;
      const response = await this.axiosInstance.post(`/gateway/default/${DEVELOPER_ID}/${SCOPE_ID}`, params, {
        headers: headers
      });
      console.log(response);
      return {
        ...response.data,
        'X-Conversation-Id': (response === null || response === void 0 || (_response$headers = response.headers) === null || _response$headers === void 0 ? void 0 : _response$headers.get('X-Conversation-Id')) ?? (response === null || response === void 0 || (_response$data = response.data) === null || _response$data === void 0 ? void 0 : _response$data['X-Conversation-Id']) ?? null
      };
    } catch (error) {
      var _error$response, _error$response3;
      //In case response have error code
      if (error !== null && error !== void 0 && (_error$response = error.response) !== null && _error$response !== void 0 && (_error$response = _error$response.data) !== null && _error$response !== void 0 && _error$response.code) {
        var _error$response2;
        return error === null || error === void 0 || (_error$response2 = error.response) === null || _error$response2 === void 0 ? void 0 : _error$response2.data;
      }

      //In case response have error array
      if (error !== null && error !== void 0 && (_error$response3 = error.response) !== null && _error$response3 !== void 0 && (_error$response3 = _error$response3.data) !== null && _error$response3 !== void 0 && _error$response3.length) {
        var _error$response4, _error$response4$join;
        return {
          code: _ErrorHandler.default.getErrorCode(error === null || error === void 0 ? void 0 : error.message) ?? 1,
          description: error === null || error === void 0 || (_error$response4 = error.response) === null || _error$response4 === void 0 || (_error$response4 = _error$response4.data) === null || _error$response4 === void 0 || (_error$response4$join = _error$response4.join) === null || _error$response4$join === void 0 ? void 0 : _error$response4$join.call(_error$response4, ', '),
          lang: 'EN'
        };
      }
      throw error;
    }
  };
}
exports.ExpressionApi = ExpressionApi;
//# sourceMappingURL=ExpressionApi.js.map