"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.RemoteStorageServiceModule = void 0;
var _AzureBlobStorageService = require("./AzureBlobStorageService");
var _FirebaseStorageService = require("./FirebaseStorageService");
var _S3BucketStorageService = require("./S3BucketStorageService");
class RemoteStorageServiceModule {
  getInstance() {
    return this.service;
  }
  setup(configData) {
    if (configData !== null && configData !== void 0 && configData.s3BucketConfig) {
      this.service = new _S3BucketStorageService.S3BucketStorageService(configData.s3BucketConfig);
    } else if (configData !== null && configData !== void 0 && configData.azureBlobStorageConfig) {
      this.service = new _AzureBlobStorageService.AzureBlobStorageService(configData.azureBlobStorageConfig);
    } else if (configData !== null && configData !== void 0 && configData.firebaseStorageConfig) {
      this.service = new _FirebaseStorageService.FirebaseStorageService(configData.firebaseStorageConfig);
    }
  }
  uploadFile = async (path, uploadFileName) => {
    return this.service.uploadFile(path, uploadFileName);
  };
}
exports.RemoteStorageServiceModule = RemoteStorageServiceModule;
const RemoteStorageModule = new RemoteStorageServiceModule();
var _default = RemoteStorageModule;
exports.default = _default;
//# sourceMappingURL=RemoteStorageModule.js.map