"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.S3BucketStorageService = void 0;
var _utils = require("../../utils");
var _RemoteStorageService = require("./RemoteStorageService");
var _awsSdk = _interopRequireDefault(require("aws-sdk"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class S3BucketStorageService extends _RemoteStorageService.RemoteStorageService {
  constructor(config) {
    super();
    _awsSdk.default.config.update(config.options);
    this.s3 = new _awsSdk.default.S3();
    this.bucketName = config.bucketName;
  }
  uploadFile = async (path, uploadFileName) => {
    try {
      const blob = await _utils.FileHelper.uriToBlob(path);
      const result = await this.s3.upload({
        Bucket: this.bucketName,
        Key: uploadFileName,
        Body: blob
      }).promise();
      console.log(result);
      return result === null || result === void 0 ? void 0 : result.Location;
    } catch (e) {
      console.log(e);
      return '';
    }
  };
}
exports.S3BucketStorageService = S3BucketStorageService;
//# sourceMappingURL=S3BucketStorageService.js.map