"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
class MyEventEmitter {
  constructor() {
    this._events = {};
  }
  on(name, listener) {
    if (!this._events[name]) {
      this._events[name] = [];
    }
    this._events[name].push(listener);
    return listener;
  }
  emit(name, data) {
    // if (!this._events[name]) {
    //   throw new Error(`Can't emit an event. Event "${name}" doesn't exits.`);
    // }
    if (!this._events[name]) {
      this._events[name] = [];
    }
    const fireCallbacks = callback => {
      callback(data);
    };
    this._events[name].forEach(fireCallbacks);
    return this;
  }
  removeListener(name, listenerToRemove) {
    if (!listenerToRemove) {
      return this;
    }
    if (!this._events[name]) {
      throw new Error(`Can't remove a listener. Event "${name}" doesn't exits.`);
    }
    const filterListeners = listener => listener !== listenerToRemove;
    this._events[name] = this._events[name].filter(filterListeners);
    return this;
  }
  removeAllListeners() {
    this._events = {};
    return this;
  }
}
exports.default = MyEventEmitter;
//# sourceMappingURL=MyEventEmitter.js.map