"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _ = require(".");
class ErrorHandler {
  constructor() {}
  static handleGatewayError = error => {
    // Is match format of GatewayResponse
    if (error !== null && error !== void 0 && error.code && error !== null && error !== void 0 && error.description) {
      return error;
    }
    // get error code
    const errorCode = typeof error === 'number' ? error : typeof (error === null || error === void 0 ? void 0 : error.code) === 'number' ? error === null || error === void 0 ? void 0 : error.code : this.getErrorCode((error === null || error === void 0 ? void 0 : error.message) ?? error);
    const eFromCode = error instanceof _.ErrorWithCode ? error : (0, _.errorFromCode)(errorCode ?? error);
    return {
      code: (eFromCode === null || eFromCode === void 0 ? void 0 : eFromCode.code) ?? errorCode ?? -1,
      description: (eFromCode === null || eFromCode === void 0 ? void 0 : eFromCode.message) ?? (eFromCode === null || eFromCode === void 0 ? void 0 : eFromCode.name) ?? (error === null || error === void 0 ? void 0 : error.message) ?? 'UNKNOWN_ERROR',
      language: 'EN'
    };
  };
  static getErrorCode = errorString => {
    const codes = errorString.match(/[\d]+/g);
    return Number(codes === null || codes === void 0 ? void 0 : codes[0]);
  };
}
exports.default = ErrorHandler;
//# sourceMappingURL=ErrorHandler.js.map