"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFileExtensions = getFileExtensions;
exports.getFileName = getFileName;
exports.getFileSize = getFileSize;
/* eslint-disable no-bitwise */
/* eslint-disable no-useless-escape */
function getFileName(fullPath, notIncludedSuffix) {
  let name = fullPath.replace(/^.*[\\\/]/, '');
  return notIncludedSuffix ? name.split('.')[0] : name;
}
function getFileExtensions(fullPath) {
  const ext = fullPath.slice((fullPath.lastIndexOf('.') - 1 >>> 0) + 2);
  if (ext !== null && ext !== void 0 && ext.startsWith(' ')) {
    return '';
  }
  return ext;
}
function getFileSize(bytes) {
  let pos = 0;
  let val = bytes;
  while (val >= 1024 && pos < MemoryUnits.length) {
    val = val / 1024;
    pos++;
  }
  return val.toFixed(val < 10 && pos > 0 ? 1 : 0) + ' ' + MemoryUnits[pos];
}
const MemoryUnits = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
//# sourceMappingURL=StringHelper.js.map