"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vs = exports.verticalScale = exports.st = exports.screenWidth = exports.screenHeight = exports.scaleText = exports.scale = exports.s = exports.moderateScale = void 0;
var _reactNative = require("react-native");
const {
  width: screenWidth,
  height: screenHeight
} = _reactNative.Dimensions.get('window');
exports.screenHeight = screenHeight;
exports.screenWidth = screenWidth;
const guidelineBaseWidth = 390;
const guidelineBaseHeight = 844;
const scale = size => screenWidth / guidelineBaseWidth * size;
exports.scale = exports.s = scale;
const verticalScale = size => screenHeight / guidelineBaseHeight * size;
exports.verticalScale = exports.vs = verticalScale;
const moderateScale = function (size) {
  let factor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.5;
  return size + (scale(size) - size) * factor;
};
exports.moderateScale = moderateScale;
const scaleText = size => screenHeight > screenWidth ? scale(size) : verticalScale(size);
exports.scaleText = exports.st = scaleText;
//# sourceMappingURL=scaler.js.map