import React from 'react';
import { FlatList, StyleSheet, Text, TouchableOpacity, View } from 'react-native';
import { s, st, vs } from '../../utils';
import { isIOS } from '../../utils/constants/constants';
import colors from '../../utils/theme/colors';
import Spacer from '../CustomView/Spacer';
import CustomImage from '../CustomView/CustomImage';
const IMAGE_DEFAULT_HEIGHT = vs(112);
const CustomCardList = _ref => {
  var _restProps$currentMes;
  let {
    onButtonPress,
    // lightboxProps,
    ...restProps
  } = _ref;
  const renderCardItem = (itm, idx) => {
    var _itm$buttons;
    return /*#__PURE__*/React.createElement(View, {
      key: `card-item-${itm === null || itm === void 0 ? void 0 : itm.title}-${idx}`,
      style: styles.card
    }, /*#__PURE__*/React.createElement(View, {
      style: styles.contentWrapper
    }, itm !== null && itm !== void 0 && itm['image-url'] ? /*#__PURE__*/React.createElement(CustomImage, {
      uri: itm === null || itm === void 0 ? void 0 : itm['image-url'],
      fixedHeight: IMAGE_DEFAULT_HEIGHT
    }) : undefined, /*#__PURE__*/React.createElement(Spacer, {
      height: 10
    }), /*#__PURE__*/React.createElement(Text, {
      style: styles.title
    }, itm === null || itm === void 0 ? void 0 : itm.title), /*#__PURE__*/React.createElement(Spacer, {
      height: 10
    }), /*#__PURE__*/React.createElement(Text, {
      style: styles.subTitle
    }, itm === null || itm === void 0 ? void 0 : itm['sub-title']), /*#__PURE__*/React.createElement(Spacer, {
      height: 10
    }), itm === null || itm === void 0 || (_itm$buttons = itm.buttons) === null || _itm$buttons === void 0 ? void 0 : _itm$buttons.map((btn, bIdx) => {
      return /*#__PURE__*/React.createElement(TouchableOpacity, {
        key: `card-btn-${btn === null || btn === void 0 ? void 0 : btn.label}-${bIdx}`,
        style: styles.cardButton,
        onPress: () => {
          onButtonPress === null || onButtonPress === void 0 ? void 0 : onButtonPress(btn, idx);
        }
      }, /*#__PURE__*/React.createElement(Text, {
        style: styles.buttonText
      }, btn === null || btn === void 0 ? void 0 : btn.label));
    })));
  };
  return /*#__PURE__*/React.createElement(FlatList, {
    horizontal: true,
    style: styles.flatList,
    contentContainerStyle: styles.flexGrowOne,
    data: (restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.cards) ?? [],
    renderItem: _ref2 => {
      let {
        item: it,
        index: idx
      } = _ref2;
      return renderCardItem(it, idx);
    }
  });
};
export default CustomCardList;
const styles = StyleSheet.create({
  flexGrowOne: {
    flexGrow: 1
  },
  flatList: {
    flex: 1,
    minHeight: vs(140)
  },
  card: {
    width: s(237),
    justifyContent: 'space-between',
    alignItems: 'center',
    backgroundColor: colors.white,
    borderRadius: st(5),
    padding: st(10),
    marginHorizontal: s(10)
  },
  contentWrapper: {
    width: '100%',
    backgroundColor: colors.porcelian
  },
  image: {
    // width: s(214),
    height: vs(137),
    borderRadius: st(5),
    margin: st(3),
    resizeMode: 'cover'
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  cardButton: {
    minHeight: vs(36),
    backgroundColor: colors.white,
    borderRadius: st(20),
    paddingVertical: vs(10),
    paddingHorizontal: s(8),
    marginHorizontal: s(8),
    marginBottom: vs(8),
    justifyContent: 'center',
    alignItems: 'center'
  },
  buttonText: {
    color: colors.shark,
    fontWeight: isIOS ? '700' : 'bold',
    fontSize: st(14),
    lineHeight: st(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  title: {
    color: colors.shark,
    fontWeight: isIOS ? '700' : 'bold',
    fontSize: st(14),
    lineHeight: st(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center',
    alignSelf: 'flex-start'
  },
  subTitle: {
    color: colors.shark,
    fontWeight: isIOS ? '600' : 'bold',
    fontSize: st(12),
    lineHeight: st(20),
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center',
    alignSelf: 'flex-start'
  }
});
//# sourceMappingURL=CustomCardList.js.map