function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useRef, useState } from 'react';
import { Image, StyleSheet, Text, TouchableOpacity, View } from 'react-native';
import { screenHeight, screenWidth, st, vs } from '../../../../utils';
import colors from '../../../../utils/theme/colors';
import AutoHeightImage from 'react-native-auto-height-image';
import images from '../../../../utils/theme/image';
import Video from 'react-native-video';
import Pdf from 'react-native-pdf';
import { isIOS } from '../../../../utils/constants/constants';
import Spacer from '../../../CustomView/Spacer';
import PreviewAudioPlayer from './PreviewAudioPlayer';
const AttachmentPreview = _ref => {
  let {
    attachments,
    onClose,
    onRemove,
    style,
    ...restProps
  } = _ref;
  //States
  const [paused, setPaused] = useState(true);
  //Refs
  const videoRef = useRef(null);
  const renderAttachmentImage = (itm, idx) => {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
      style: styles.rowContainer
    }, /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/React.createElement(AutoHeightImage, {
      width: screenWidth - styles.container.padding * 2,
      source: {
        uri: itm.uri
      },
      resizeMode: 'contain',
      style: styles.imageAtt
    }));
  };
  const renderAttachmentVideo = (itm, idx) => {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
      style: styles.rowContainer
    }, /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/React.createElement(View, {
      style: styles.videoContainer
    }, /*#__PURE__*/React.createElement(Video, {
      ref: videoRef,
      source: {
        uri: itm.uri
      },
      resizeMode: 'contain',
      style: styles.videoAtt,
      onLoad: _videoData => {
        var _videoRef$current;
        videoRef === null || videoRef === void 0 || (_videoRef$current = videoRef.current) === null || _videoRef$current === void 0 ? void 0 : _videoRef$current.seek(0);
        setPaused(true);
      },
      onLoadStart: () => {},
      paused: paused,
      controls: true
    })));
  };
  const renderAttachmentPDF = (itm, idx) => {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
      style: styles.rowContainer
    }, /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/React.createElement(Text, {
      style: styles.title,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.name), /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/React.createElement(Pdf, {
      source: {
        uri: itm.uri
      },
      onLoadComplete: (numberOfPages, _filePath) => {
        console.log(`Number of pages: ${numberOfPages}`);
      },
      onPageChanged: (page, _numberOfPages) => {
        console.log(`Current page: ${page}`);
      },
      onError: error => {
        console.log(error);
      },
      onPressLink: uri => {
        console.log(`Link pressed: ${uri}`);
      },
      style: styles.pdfAtt
    }));
  };
  const renderAttachmentAudioPlayer = (itm, idx) => {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(PreviewAudioPlayer, {
      audioPath: itm === null || itm === void 0 ? void 0 : itm.uri,
      onRemove: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }), /*#__PURE__*/React.createElement(Spacer, {
      height: 20
    }));
  };
  const renderAttachmentUnknown = (itm, idx) => {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
      style: styles.rowContainer
    }, /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onClose === null || onClose === void 0 ? void 0 : onClose();
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_close,
      resizeMode: 'contain',
      style: styles.imageCloseBtn
    })), /*#__PURE__*/React.createElement(Text, {
      style: styles.title,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.name), /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: () => {
        onRemove === null || onRemove === void 0 ? void 0 : onRemove(itm, idx);
      }
    }, /*#__PURE__*/React.createElement(Image, {
      source: images.ic_trash_bin,
      resizeMode: 'contain',
      style: styles.imageTrashBtn
    }))), /*#__PURE__*/React.createElement(Spacer, {
      height: 20
    }), /*#__PURE__*/React.createElement(Text, {
      style: styles.text,
      numberOfLines: 1,
      ellipsizeMode: 'middle'
    }, itm === null || itm === void 0 ? void 0 : itm.type), /*#__PURE__*/React.createElement(Spacer, {
      height: 20
    }));
  };
  const renderAttachmentItem = (itm, idx) => {
    let content;
    const lowerCaseType = itm.type.toLowerCase();
    if (lowerCaseType.includes('image')) {
      content = renderAttachmentImage(itm, idx);
    } else if (lowerCaseType.includes('video')) {
      content = renderAttachmentVideo(itm, idx);
    } else if (lowerCaseType.includes('pdf')) {
      content = renderAttachmentPDF(itm, idx);
    } else if (lowerCaseType.includes('audio')) {
      content = renderAttachmentAudioPlayer(itm, idx);
    } else {
      content = renderAttachmentUnknown(itm, idx);
    }
    return /*#__PURE__*/React.createElement(View, {
      key: `attachment-${itm}-${idx}`
    }, content);
  };
  return /*#__PURE__*/React.createElement(View, _extends({
    style: [styles.container, style]
  }, restProps), attachments === null || attachments === void 0 ? void 0 : attachments.map((it, idx) => renderAttachmentItem(it, idx)));
};
export default AttachmentPreview;
const styles = StyleSheet.create({
  container: {
    padding: st(20),
    maxHeight: screenHeight - vs(100)
  },
  rowContainer: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center'
  },
  imageCloseBtn: {
    width: st(17),
    height: st(17)
  },
  imageTrashBtn: {
    width: st(20),
    height: st(20)
  },
  imageAtt: {
    maxHeight: screenHeight - vs(280),
    marginVertical: vs(60),
    borderRadius: st(5)
  },
  videoContainer: {
    flex: 1,
    marginVertical: vs(60)
  },
  videoAtt: {
    borderRadius: st(5),
    width: screenWidth - st(20) * 2,
    minHeight: (screenWidth - st(20) * 2) * 9 / 16 + vs(80) // 16:9 frames + expand 80h
  },

  pdfAtt: {
    // flex: 1,
    width: screenWidth - st(20) * 2,
    height: screenHeight - vs(360),
    marginVertical: vs(10),
    borderRadius: st(5)
  },
  title: {
    fontSize: st(16),
    color: colors.shark,
    fontWeight: isIOS ? '600' : 'bold',
    letterSpacing: -0.02,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  text: {
    fontSize: st(12),
    color: colors.black,
    textAlign: 'center',
    textAlignVertical: 'center'
  }
});
//# sourceMappingURL=AttachmentPreview.js.map