function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import moment from 'moment';
import React, { useEffect, useState } from 'react';
import { StyleSheet, Text, View } from 'react-native';
import { Bubble } from 'react-native-gifted-chat';
import { isIOS } from '../../utils/constants/constants';
import colors from '../../utils/theme/colors';
import { FileHelper, StringHelper, s, st, vs } from '../../utils';
import CustomCardList from './CustomCardList';
import CustomArrow from '../CustomView/CustomArrow';
import CustomQuickReply from './CustomQuickReply';
import CustomDateTimePickerMessage from './CustomDateTimePickerMessage';
import { AUDIO_EXTENSIONS_REGEX, IMAGE_EXTENSIONS_REGEX, URL_REGEX, VIDEO_EXTENSIONS_REGEX } from '../../utils/constants/AppConstants';
import VideoPlayer from '../CustomView/VideoPlayer';
import AudioPlayer from '../CustomView/AudioPlayer';
import CustomFile from './CustomFile';
import queryString from 'query-string';
const CustomMessage = _ref => {
  var _currentMessage$user, _localProps$nextMessa;
  let {
    onCardButtonPress,
    onQuickReplyItemPress,
    onDateTimeSelect,
    ...restProps
  } = _ref;
  //States
  const [localProps, setLocalProps] = useState(restProps);
  //Vars
  const currentMessage = localProps.currentMessage;
  const sameUserInNextMessage = (currentMessage === null || currentMessage === void 0 || (_currentMessage$user = currentMessage.user) === null || _currentMessage$user === void 0 ? void 0 : _currentMessage$user._id) === ((_localProps$nextMessa = localProps.nextMessage) === null || _localProps$nextMessa === void 0 || (_localProps$nextMessa = _localProps$nextMessa.user) === null || _localProps$nextMessa === void 0 ? void 0 : _localProps$nextMessa._id);
  // const isCurrentUser = currentUserId == currentMessage?.user?._id;
  const orientationStyle = (localProps === null || localProps === void 0 ? void 0 : localProps.position) === 'right' ? styles.right : styles.left;
  //Effects
  useEffect(() => {
    reformatProps();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  const reformatProps = async () => {
    let newProps = localProps;
    let blob;
    if (currentMessage !== null && currentMessage !== void 0 && currentMessage.text) {
      var _lowerMsg$split, _blob;
      const pathReader = queryString.parseUrl(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text);
      const lowerMsg = ((pathReader === null || pathReader === void 0 ? void 0 : pathReader.url) ?? '').toLowerCase();
      const ext = StringHelper.getFileExtensions(lowerMsg);
      //Show temp UI (three dot) if the message is link with extenstion
      if (ext && URL_REGEX.test(lowerMsg) && (lowerMsg === null || lowerMsg === void 0 || (_lowerMsg$split = lowerMsg.split(/[/|\\\\]/)) === null || _lowerMsg$split === void 0 ? void 0 : _lowerMsg$split.length) >= 4) {
        let tempProps = {
          ...localProps,
          currentMessage: {
            ...currentMessage,
            text: '...'
          }
        };
        setLocalProps(tempProps);
      }
      try {
        blob = await FileHelper.uriToBlob(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text);
      } catch (e) {}
      if ((_blob = blob) !== null && _blob !== void 0 && _blob.size) {
        if (IMAGE_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              image: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else if (AUDIO_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              audio: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else if (VIDEO_EXTENSIONS_REGEX.test(lowerMsg)) {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              video: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        } else {
          newProps = {
            ...localProps,
            currentMessage: {
              ...currentMessage,
              text: '',
              file: currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.text
            }
          };
        }
      }
    }
    setLocalProps(newProps);
  };
  const renderBubble = () => {
    return /*#__PURE__*/React.createElement(CustomArrow, {
      position: localProps === null || localProps === void 0 ? void 0 : localProps.position,
      borderColor: colors.blueBayoux20,
      borderWidth: 1
    }, /*#__PURE__*/React.createElement(Bubble, _extends({}, localProps, {
      renderTime: _timeProps => undefined,
      wrapperStyle: {
        left: [styles.bubble, styles.bubbleLeft],
        right: [styles.bubble, styles.bubbleRight]
      },
      textStyle: {
        left: styles.messageText,
        right: [styles.messageText, styles.messageTextRight]
      },
      renderMessageVideo: videoProps => {
        var _videoProps$currentMe;
        const uri = (_videoProps$currentMe = videoProps.currentMessage) === null || _videoProps$currentMe === void 0 ? void 0 : _videoProps$currentMe.video;
        if (!uri) {
          return /*#__PURE__*/React.createElement(View, null);
        }
        return /*#__PURE__*/React.createElement(VideoPlayer, {
          uri: uri,
          style: styles.video
        });
      },
      renderMessageAudio: audioProps => {
        var _audioProps$currentMe;
        const uri = (_audioProps$currentMe = audioProps.currentMessage) === null || _audioProps$currentMe === void 0 ? void 0 : _audioProps$currentMe.audio;
        if (!uri) {
          return /*#__PURE__*/React.createElement(View, null);
        }
        return /*#__PURE__*/React.createElement(AudioPlayer, {
          uri: uri
        });
      },
      renderCustomView: customProps => {
        var _customProps$currentM;
        if (customProps !== null && customProps !== void 0 && (_customProps$currentM = customProps.currentMessage) !== null && _customProps$currentM !== void 0 && _customProps$currentM.file) {
          return /*#__PURE__*/React.createElement(CustomFile, _extends({}, customProps, {
            wrapperStyle: {
              left: [styles.bubble, styles.bubbleLeft],
              right: [styles.bubble, styles.bubbleRight]
            }
          }));
        }
      }
    })));
  };
  const renderContent = () => {
    var _localProps$currentMe;
    switch (localProps === null || localProps === void 0 || (_localProps$currentMe = localProps.currentMessage) === null || _localProps$currentMe === void 0 ? void 0 : _localProps$currentMe.templateType) {
      case 'card':
        {
          return /*#__PURE__*/React.createElement(CustomCardList, _extends({}, localProps, {
            onButtonPress: (btn, idx) => {
              onCardButtonPress === null || onCardButtonPress === void 0 ? void 0 : onCardButtonPress(btn, idx);
            }
          }));
        }
      case 'quick_reply':
        {
          var _localProps$currentMe2;
          if (localProps !== null && localProps !== void 0 && (_localProps$currentMe2 = localProps.currentMessage) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2.quickReplies) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2.values) !== null && _localProps$currentMe2 !== void 0 && (_localProps$currentMe2 = _localProps$currentMe2[0]) !== null && _localProps$currentMe2 !== void 0 && _localProps$currentMe2.value) {
            return /*#__PURE__*/React.createElement(CustomQuickReply, _extends({}, localProps, {
              onCutomQuickReply: (itm, idx) => {
                onQuickReplyItemPress === null || onQuickReplyItemPress === void 0 ? void 0 : onQuickReplyItemPress(itm, idx);
              }
            }));
          }
          return renderBubble();
        }
      case 'datetime':
        {
          var _localProps$currentMe3;
          if (localProps !== null && localProps !== void 0 && (_localProps$currentMe3 = localProps.currentMessage) !== null && _localProps$currentMe3 !== void 0 && _localProps$currentMe3.datetime) {
            var _localProps$currentMe4;
            const pickerProps = localProps === null || localProps === void 0 || (_localProps$currentMe4 = localProps.currentMessage) === null || _localProps$currentMe4 === void 0 ? void 0 : _localProps$currentMe4.datetime;
            return /*#__PURE__*/React.createElement(CustomDateTimePickerMessage, _extends({}, localProps, {
              pickerProps: pickerProps,
              onConfirm: (dateTime, endDate) => {
                onDateTimeSelect === null || onDateTimeSelect === void 0 ? void 0 : onDateTimeSelect(dateTime, endDate, pickerProps);
              }
            }));
          }
          return renderBubble();
        }
      default:
        {
          return renderBubble();
        }
    }
  };
  return /*#__PURE__*/React.createElement(View, {
    style: [styles.container, orientationStyle]
  }, renderContent(), !sameUserInNextMessage ? /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Text, {
    style: [styles.messageTime, orientationStyle]
  }, moment(currentMessage === null || currentMessage === void 0 ? void 0 : currentMessage.createdAt).format('LT'))) : undefined);
};
export default CustomMessage;
const styles = StyleSheet.create({
  container: {},
  bubble: {
    justifyContent: 'center',
    borderRadius: st(5),
    //FIXME: show empty msg
    minHeight: vs(30),
    minWidth: s(20),
    borderWidth: s(1),
    borderColor: colors.blueBayoux20
  },
  bubbleLeft: {
    backgroundColor: colors.white,
    marginLeft: s(2)
  },
  bubbleRight: {
    backgroundColor: colors.blueBayoux,
    marginRight: s(2)
  },
  right: {
    flex: 1,
    alignSelf: 'flex-end'
  },
  left: {
    flex: 1,
    alignSelf: 'flex-start'
  },
  messageTime: {
    paddingHorizontal: s(12),
    color: colors.grayChateau,
    fontWeight: isIOS ? '400' : 'normal',
    fontSize: st(10),
    lineHeight: st(14),
    letterSpacing: -0.02,
    marginTop: vs(2)
  },
  messageText: {
    color: colors.shark,
    fontWeight: isIOS ? '600' : 'bold',
    fontSize: st(12),
    lineHeight: st(16),
    letterSpacing: -0.02
  },
  messageTextRight: {
    color: colors.white
  },
  video: {
    margin: st(5),
    borderRadius: st(5)
  }
});
//# sourceMappingURL=CustomMessage.js.map