function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useEffect, useState } from 'react';
import { ActivityIndicator, Image, StyleSheet, View } from 'react-native';
import { MessageImage } from 'react-native-gifted-chat';
import { s, st, vs } from '../../utils';
import colors from '../../utils/theme/colors';
const IMAGE_DEFAULT_WIDTH = s(260);
const IMAGE_DEFAULT_HEIGHT = vs(150);
const CustomMessageImage = _ref => {
  let {
    ...restProps
  } = _ref;
  //States
  const [imageWidth, setImageWidth] = useState(0);
  const [imageheight, setImageHeight] = useState(0);
  const [isImageFetching, setIsImageFetching] = useState();
  //Vars
  const calculatedHeight = imageheight * IMAGE_DEFAULT_WIDTH / (imageWidth ?? 1);
  //Effects
  useEffect(() => {
    getSize();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [restProps === null || restProps === void 0 ? void 0 : restProps.currentMessage]);
  const getSize = async () => {
    var _restProps$currentMes;
    const uri = restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.image;
    if (uri) {
      Image.getSize(uri, (width, height) => {
        // console.log(width, height);
        setImageWidth(isNaN(width) ? IMAGE_DEFAULT_WIDTH : width);
        setImageHeight(isNaN(height) ? IMAGE_DEFAULT_HEIGHT : height);
      }, e => {
        console.log(e);
        setImageWidth(IMAGE_DEFAULT_WIDTH);
        setImageHeight(IMAGE_DEFAULT_HEIGHT);
      });
    }
  };
  return /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(MessageImage, _extends({}, restProps, {
    imageStyle: [styles.image, {
      width: IMAGE_DEFAULT_WIDTH,
      height: calculatedHeight ? calculatedHeight : IMAGE_DEFAULT_HEIGHT
    }],
    imageProps: {
      onLoadStart: () => {
        if (isImageFetching !== false) {
          // false mean it already loaded
          setIsImageFetching(true);
        }
      },
      onLoadEnd: () => {
        setIsImageFetching(false);
      }
    },
    containerStyle: styles.container
  })), !imageWidth || !imageheight || isImageFetching ? /*#__PURE__*/React.createElement(ActivityIndicator, {
    style: styles.activityIndicator,
    color: colors.mountainMeadow
  }) : undefined);
};
export default CustomMessageImage;
const styles = StyleSheet.create({
  container: {
    borderRadius: st(5)
  },
  image: {
    width: s(260),
    height: vs(150),
    borderRadius: st(5),
    margin: st(5)
  },
  activityIndicator: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0,
    padding: st(10)
  }
});
//# sourceMappingURL=CustomMessageImage.js.map