import React from 'react';
import { StyleSheet, Text, TouchableOpacity, View } from 'react-native';
import { s, st, vs } from '../../utils';
import CustomArrow from '../CustomView/CustomArrow';
import colors from '../../utils/theme/colors';
import { isIOS } from '../../utils/constants/constants';
import CustomImage from '../CustomView/CustomImage';
const IMAGE_DEFAULT_HEIGHT = vs(112);
const CustomQuickReply = _ref => {
  var _restProps$currentMes, _restProps$currentMes2;
  let {
    onCutomQuickReply,
    // lightboxProps,
    ...restProps
  } = _ref;
  const quickReplies = (restProps === null || restProps === void 0 || (_restProps$currentMes = restProps.currentMessage) === null || _restProps$currentMes === void 0 || (_restProps$currentMes = _restProps$currentMes.quickReplies) === null || _restProps$currentMes === void 0 ? void 0 : _restProps$currentMes.values) ?? [];
  const renderQuickReplyItem = (itm, idx) => {
    return /*#__PURE__*/React.createElement(View, {
      key: `quickreply-item-${itm === null || itm === void 0 ? void 0 : itm.title}-${idx}`
    }, itm !== null && itm !== void 0 && itm['image-uri'] ? /*#__PURE__*/React.createElement(CustomImage, {
      uri: itm === null || itm === void 0 ? void 0 : itm['image-uri'],
      fixedHeight: IMAGE_DEFAULT_HEIGHT
    }) : undefined, /*#__PURE__*/React.createElement(TouchableOpacity, {
      style: styles.button,
      onPress: () => {
        onCutomQuickReply === null || onCutomQuickReply === void 0 ? void 0 : onCutomQuickReply(itm, idx);
      }
    }, /*#__PURE__*/React.createElement(Text, {
      style: styles.buttonText
    }, itm === null || itm === void 0 ? void 0 : itm.title)));
  };
  return /*#__PURE__*/React.createElement(CustomArrow, {
    position: restProps === null || restProps === void 0 ? void 0 : restProps.position,
    borderColor: colors.blueBayoux20,
    borderWidth: 1
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.bubble
  }, /*#__PURE__*/React.createElement(Text, {
    style: [styles.messageText, (restProps === null || restProps === void 0 ? void 0 : restProps.position) === 'right' ? styles.messageTextRight : undefined]
  }, restProps === null || restProps === void 0 || (_restProps$currentMes2 = restProps.currentMessage) === null || _restProps$currentMes2 === void 0 ? void 0 : _restProps$currentMes2.text), /*#__PURE__*/React.createElement(View, {
    style: styles.separator
  }), /*#__PURE__*/React.createElement(View, {
    style: styles.wrapContent
  }, quickReplies === null || quickReplies === void 0 ? void 0 : quickReplies.map((it, idx) => renderQuickReplyItem(it, idx)))));
};
export default CustomQuickReply;
const styles = StyleSheet.create({
  flexGrowOne: {
    flexGrow: 1
  },
  bubble: {
    maxWidth: s(251),
    justifyContent: 'flex-start',
    borderWidth: 1,
    borderColor: colors.blueBayoux20,
    // alignItems: 'center',
    backgroundColor: colors.white,
    borderRadius: st(5),
    paddingVertical: vs(6),
    paddingHorizontal: s(10),
    //FIXME: show empty msg
    minHeight: vs(30),
    minWidth: s(20),
    marginHorizontal: s(2)
  },
  wrapContent: {
    justifyContent: 'flex-start',
    maxWidth: s(230),
    flexDirection: 'row',
    flexWrap: 'wrap'
  },
  button: {
    backgroundColor: colors.mountainMeadow,
    borderRadius: st(5),
    paddingVertical: vs(10),
    paddingHorizontal: vs(8),
    marginRight: s(10),
    marginBottom: vs(8)
  },
  image: {
    width: st(48),
    height: st(48)
  },
  imageActive: {
    flex: 1,
    resizeMode: 'contain'
  },
  messageText: {
    color: colors.shark,
    fontWeight: isIOS ? '600' : 'bold',
    fontSize: st(12),
    lineHeight: st(16),
    letterSpacing: -0.02,
    alignSelf: 'flex-start'
  },
  messageTextRight: {
    color: colors.white
  },
  separator: {
    height: 1,
    width: '100%',
    backgroundColor: colors.blueBayoux20,
    marginVertical: vs(4)
  },
  buttonText: {
    color: colors.white,
    fontWeight: isIOS ? '600' : 'bold',
    fontSize: st(12),
    lineHeight: st(16),
    letterSpacing: -0.02
  }
});
//# sourceMappingURL=CustomQuickReply.js.map