function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useState, useEffect } from 'react';
import { GiftedChat } from 'react-native-gifted-chat';
import { DataConverter } from '../../utils/DataConverter';
import CustomAvatar from '../ChatItem/CustomAvatar';
import CustomMessageImage from '../ChatItem/CustomMessageImage';
import CustomMessage from '../ChatItem/CustomMessage';
import { StyleSheet } from 'react-native';
import CustomInputToolbar from '../ChatItem/CustomInputToolbar/CustomInputToolbar';
const ChatList = _ref => {
  let {
    data,
    messages = [],
    onCardButtonPress,
    onQuickReplyItemPress,
    onDateTimeSelect,
    ...restProps
  } = _ref;
  const [chatData, setChatData] = useState([]);
  useEffect(() => {
    var _messages$concat;
    const convertedData = data === null || data === void 0 ? void 0 : data.map(it => DataConverter.conversationDataToIMessage(it));
    const sortedData = (_messages$concat = messages.concat(convertedData)) === null || _messages$concat === void 0 ? void 0 : _messages$concat.sort((a, b) => {
      var _a$createdAt, _b$createdAt;
      return a.createdAt && b.createdAt && ((_a$createdAt = a.createdAt) === null || _a$createdAt === void 0 ? void 0 : _a$createdAt.valueOf()) < ((_b$createdAt = b.createdAt) === null || _b$createdAt === void 0 ? void 0 : _b$createdAt.valueOf()) ? 1 : -1;
    });
    setChatData(sortedData);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [data]);
  return /*#__PURE__*/React.createElement(GiftedChat, _extends({
    messagesContainerStyle: styles.container,
    messages: chatData,
    renderAvatarOnTop: true,
    renderAvatar: props => {
      return /*#__PURE__*/React.createElement(CustomAvatar, props);
    },
    renderMessageImage: props => /*#__PURE__*/React.createElement(CustomMessageImage, props),
    renderBubble: props => /*#__PURE__*/React.createElement(CustomMessage, _extends({}, props, {
      onCardButtonPress: onCardButtonPress,
      onQuickReplyItemPress: onQuickReplyItemPress,
      onDateTimeSelect: onDateTimeSelect
    })),
    renderInputToolbar: props => /*#__PURE__*/React.createElement(CustomInputToolbar, props),
    shouldUpdateMessage: (currProps, nextProps) =>
    //@ts-ignore
    currProps.extraData !== nextProps.extraData
  }, restProps));
};
export default ChatList;
const styles = StyleSheet.create({
  container: {}
});
//# sourceMappingURL=ChatList.js.map