function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React from 'react';
import { Image, StyleSheet, Text, View } from 'react-native';
import { s, st, vs } from '../../../../utils';
import SelectDropdown from 'react-native-select-dropdown';
import colors from '../../../../utils/theme/colors';
import { isIOS } from '../../../../utils/constants/constants';
import images from '../../../../utils/theme/image';
import { translate } from '../../../../i18n';
const CustomTimeDropdown = _ref => {
  let {
    buttonStyle,
    locale,
    ...restProps
  } = _ref;
  const renderTextLabel = (item, _index) => {
    const valStr = typeof item === 'number' && item < 10 ? `0${item}` : item === null || item === void 0 ? void 0 : item.toString();
    return /*#__PURE__*/React.createElement(Text, {
      style: styles.text
    }, translate(valStr, undefined, locale));
  };
  const renderTextItem = (item, index) => {
    const valStr = typeof item === 'number' && item < 10 ? `0${item}` : item === null || item === void 0 ? void 0 : item.toString();
    return /*#__PURE__*/React.createElement(View, {
      style: styles.textItem,
      key: `textItem-${index}`
    }, /*#__PURE__*/React.createElement(Text, {
      style: [styles.text, styles.opionText]
    }, translate(valStr, undefined, locale)));
  };
  const renderSelectedContent = (selectedItem, index) => {
    return /*#__PURE__*/React.createElement(View, {
      style: styles.rowContainer
    }, renderTextLabel(selectedItem, index), /*#__PURE__*/React.createElement(Image, {
      source: images.ic_arrow_down,
      resizeMode: 'contain',
      style: styles.arrowDown
    }));
  };
  return /*#__PURE__*/React.createElement(View, {
    style: styles.container
  }, /*#__PURE__*/React.createElement(SelectDropdown, _extends({}, restProps, {
    buttonStyle: [styles.button, buttonStyle],
    buttonTextAfterSelection: (selectedItem, _index) => {
      return selectedItem;
    },
    rowTextForSelection: (item, _index) => {
      return item;
    },
    renderCustomizedButtonChild: (selectedItem, index) => renderSelectedContent(selectedItem, index),
    renderCustomizedRowChild: (item, index) => renderTextItem(item, index)
  })));
};
export default CustomTimeDropdown;
const styles = StyleSheet.create({
  container: {},
  rowContainer: {
    flex: 1,
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    paddingHorizontal: s(6)
  },
  button: {
    flexGrow: 1,
    height: s(30),
    width: s(68),
    paddingVertical: vs(5),
    backgroundColor: colors.porcelian,
    borderWidth: st(1),
    borderColor: colors.cornflowerBlue,
    flexDirection: 'row',
    alignItems: 'center',
    paddingHorizontal: s(6)
  },
  textItem: {
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'center',
    paddingHorizontal: s(6)
  },
  text: {
    fontSize: s(12),
    color: colors.black,
    textAlign: 'center',
    textAlignVertical: 'center'
  },
  opionText: {
    flex: 1,
    fontWeight: isIOS ? '700' : 'bold',
    alignSelf: 'center'
  },
  arrowDown: {
    width: st(10),
    height: st(10)
  }
});
//# sourceMappingURL=CustomTimeDropdown.js.map