function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useMemo, useRef, useState } from 'react';
import { StyleSheet, TouchableHighlight, View } from 'react-native';
import { screenWidth } from '../../utils';
import Video from 'react-native-video';
import SvgPlayButton from '../../assets/png/ReactSvgs/SvgPlayButton';
const VideoPlayer = _ref => {
  let {
    uri,
    ...restProps
  } = _ref;
  //State
  const [pause, setPaused] = useState(true);
  //Refs
  const videoRef = useRef(null);
  const renderVideo = useMemo(() => {
    return (
      /*#__PURE__*/
      // @ts-ignore
      React.createElement(Video, _extends({}, restProps, {
        ref: videoRef,
        source: {
          uri
        },
        resizeMode: 'contain',
        style: [styles.video, restProps === null || restProps === void 0 ? void 0 : restProps.style],
        onLoad: _videoData => {
          var _videoRef$current;
          videoRef === null || videoRef === void 0 || (_videoRef$current = videoRef.current) === null || _videoRef$current === void 0 ? void 0 : _videoRef$current.seek(0);
          // setPaused(true);
        },

        paused: pause,
        onLoadStart: () => {}
        // controls={true}
      }))
    );
  }, [uri, restProps, pause]);
  return /*#__PURE__*/React.createElement(TouchableHighlight, {
    onPress: () => {
      setPaused(prev => !prev);
    }
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.videoWrapper
  }, renderVideo, pause ? /*#__PURE__*/React.createElement(SvgPlayButton, {
    style: styles.absoluteCenter
  }) : undefined));
};
export default VideoPlayer;
const styles = StyleSheet.create({
  videoWrapper: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center'
  },
  video: {
    width: screenWidth * 3 / 4,
    height: screenWidth * 3 / 4 * 9 / 16,
    justifyContent: 'center',
    alignItems: 'center'
  },
  absoluteCenter: {
    position: 'absolute',
    alignSelf: 'center'
  }
});
//# sourceMappingURL=VideoPlayer.js.map