import { DateTimeHelper } from '../../utils';
export class Logger {
  constructor() {
    this.logArray = [];
  }
  logEvent = (eventName, log, obj) => {
    this.logArray.push({
      timestamp: DateTimeHelper.getCurrentTimestamp(),
      eventName,
      log,
      logObj: obj
    });
  };
  getLogTexts = (from, to) => {
    var _this$logArray;
    const logsToPrint = (_this$logArray = this.logArray) === null || _this$logArray === void 0 ? void 0 : _this$logArray.filter(it => (!from || (it === null || it === void 0 ? void 0 : it.timestamp) >= (from === null || from === void 0 ? void 0 : from.valueOf())) && (!to || (it === null || it === void 0 ? void 0 : it.timestamp) >= (to === null || to === void 0 ? void 0 : to.valueOf())));
    return logsToPrint === null || logsToPrint === void 0 ? void 0 : logsToPrint.map(it => Logger.getLogText(it));
  };
  static getLogText = args => {
    const date = new Date(args.timestamp);
    let obj = '';
    try {
      obj = args !== null && args !== void 0 && args.logObj ? JSON.stringify(args === null || args === void 0 ? void 0 : args.logObj) : '';
    } catch (e) {
      obj = 'illegible obj';
    }
    return `- [${date === null || date === void 0 ? void 0 : date.toISOString()}] [${args === null || args === void 0 ? void 0 : args.eventName}] [${args === null || args === void 0 ? void 0 : args.log}] [${obj}]`;
  };
}
//# sourceMappingURL=Logger.js.map