import { AzureBlobStorageService } from './AzureBlobStorageService';
import { FirebaseStorageService } from './FirebaseStorageService';
import { S3BucketStorageService } from './S3BucketStorageService';
export class RemoteStorageServiceModule {
  getInstance() {
    return this.service;
  }
  setup(configData) {
    if (configData !== null && configData !== void 0 && configData.s3BucketConfig) {
      this.service = new S3BucketStorageService(configData.s3BucketConfig);
    } else if (configData !== null && configData !== void 0 && configData.azureBlobStorageConfig) {
      this.service = new AzureBlobStorageService(configData.azureBlobStorageConfig);
    } else if (configData !== null && configData !== void 0 && configData.firebaseStorageConfig) {
      this.service = new FirebaseStorageService(configData.firebaseStorageConfig);
    }
  }
  uploadFile = async (path, uploadFileName) => {
    return this.service.uploadFile(path, uploadFileName);
  };
}
const RemoteStorageModule = new RemoteStorageServiceModule();
export default RemoteStorageModule;
//# sourceMappingURL=RemoteStorageModule.js.map