import { FileHelper } from '../../utils';
import { RemoteStorageService } from './RemoteStorageService';
import AWS from 'aws-sdk';
export class S3BucketStorageService extends RemoteStorageService {
  constructor(config) {
    super();
    AWS.config.update(config.options);
    this.s3 = new AWS.S3();
    this.bucketName = config.bucketName;
  }
  uploadFile = async (path, uploadFileName) => {
    try {
      const blob = await FileHelper.uriToBlob(path);
      const result = await this.s3.upload({
        Bucket: this.bucketName,
        Key: uploadFileName,
        Body: blob
      }).promise();
      console.log(result);
      return result === null || result === void 0 ? void 0 : result.Location;
    } catch (e) {
      console.log(e);
      return '';
    }
  };
}
//# sourceMappingURL=S3BucketStorageService.js.map