import { initUUID } from './helpers/UuidHelper';
import images from './theme/image';
export class DataConverter {
  static conversationDataToIMessage(src) {
    var _src$timestamp, _src$data, _src$data2, _src$data3, _src$data4, _src$data5, _src$data6, _src$data7;
    return {
      _id: initUUID(src === null || src === void 0 || (_src$timestamp = src.timestamp) === null || _src$timestamp === void 0 ? void 0 : _src$timestamp.toString()),
      text: (src === null || src === void 0 || (_src$data = src.data) === null || _src$data === void 0 ? void 0 : _src$data.template) ?? '',
      createdAt: new Date(src === null || src === void 0 ? void 0 : src.timestamp),
      user: {
        _id: src.sender,
        name: src.sender,
        avatar: src.sender === 'CAI' ? images.ic_cai_profile : undefined
      },
      image: (_src$data2 = src.data) === null || _src$data2 === void 0 ? void 0 : _src$data2['image-url'],
      cards: src === null || src === void 0 || (_src$data3 = src.data) === null || _src$data3 === void 0 ? void 0 : _src$data3['card-list'],
      templateType: src === null || src === void 0 || (_src$data4 = src.data) === null || _src$data4 === void 0 ? void 0 : _src$data4['template-type'],
      quickReplies: src !== null && src !== void 0 && (_src$data5 = src.data) !== null && _src$data5 !== void 0 && (_src$data5 = _src$data5['quick-replies']) !== null && _src$data5 !== void 0 && _src$data5.length ? DataConverter.quickReplyObjectsArrayToCustomQuickReplies(src === null || src === void 0 || (_src$data6 = src.data) === null || _src$data6 === void 0 ? void 0 : _src$data6['quick-replies']) : undefined,
      datetime: src === null || src === void 0 || (_src$data7 = src.data) === null || _src$data7 === void 0 ? void 0 : _src$data7.datetime
    };
  }
  static iMessageToConversationData(src) {
    var _src$quickReplies, _src$createdAt;
    let sender = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'User';
    return {
      sender,
      data: {
        'template': src === null || src === void 0 ? void 0 : src.text,
        'image-url': src === null || src === void 0 ? void 0 : src.image,
        'card-list': src === null || src === void 0 ? void 0 : src.cards,
        'template-type': src === null || src === void 0 ? void 0 : src.templateType,
        'quick-replies': src !== null && src !== void 0 && (_src$quickReplies = src.quickReplies) !== null && _src$quickReplies !== void 0 && (_src$quickReplies = _src$quickReplies.values) !== null && _src$quickReplies !== void 0 && _src$quickReplies.length ? DataConverter.customQuickRepliesToQuickReplyObjectsArray(src === null || src === void 0 ? void 0 : src.quickReplies) : undefined,
        'datetime': src === null || src === void 0 ? void 0 : src.datetime
      },
      timestamp: (_src$createdAt = src.createdAt) === null || _src$createdAt === void 0 ? void 0 : _src$createdAt.valueOf()
    };
  }
  static quickReplyObjectsArrayToCustomQuickReplies(src) {
    let type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'radio';
    let keepIt = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    return {
      type,
      keepIt,
      values: src === null || src === void 0 ? void 0 : src.map(it => ({
        'title': (it === null || it === void 0 ? void 0 : it.label) ?? '',
        'value': ((it === null || it === void 0 ? void 0 : it.type) === 'link' ? it === null || it === void 0 ? void 0 : it.link : it === null || it === void 0 ? void 0 : it.message) ?? '',
        'messageId': ((it === null || it === void 0 ? void 0 : it.label) ?? '') + ((it === null || it === void 0 ? void 0 : it.message) ?? '') + (it === null || it === void 0 ? void 0 : it.link),
        'image-uri': it['image-uri'],
        'actionType': it === null || it === void 0 ? void 0 : it.type
      }))
    };
  }
  static customQuickRepliesToQuickReplyObjectsArray(src) {
    var _src$values;
    return src === null || src === void 0 || (_src$values = src.values) === null || _src$values === void 0 ? void 0 : _src$values.map(it => ({
      'label': it === null || it === void 0 ? void 0 : it.title,
      'type': it === null || it === void 0 ? void 0 : it.actionType,
      'message': (it === null || it === void 0 ? void 0 : it.actionType) === 'message' ? it === null || it === void 0 ? void 0 : it.value : undefined,
      'image-uri': it['image-uri'],
      'link': (it === null || it === void 0 ? void 0 : it.actionType) === 'link' ? it === null || it === void 0 ? void 0 : it.value : undefined
    }));
  }
}
//# sourceMappingURL=DataConverter.js.map