import { Dimensions } from 'react-native';
const {
  width: screenWidth,
  height: screenHeight
} = Dimensions.get('window');
const guidelineBaseWidth = 390;
const guidelineBaseHeight = 844;
const scale = size => screenWidth / guidelineBaseWidth * size;
const verticalScale = size => screenHeight / guidelineBaseHeight * size;
const moderateScale = function (size) {
  let factor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.5;
  return size + (scale(size) - size) * factor;
};
const scaleText = size => screenHeight > screenWidth ? scale(size) : verticalScale(size);
export { scale as s, verticalScale as vs, scaleText as st, scale, verticalScale, scaleText, moderateScale, screenWidth, screenHeight };
//# sourceMappingURL=scaler.js.map