import React from 'react';
import { RemoteStorageConfig } from '../../services/RemoteStorage/RemoteStorage.types';
import { ConversationData } from '../../MindExpressionApi/MindExpressionApi.type';
export type MindAIExpressionChatUIProps = {
    /**
     * Engine URL - You can get this on the integration page.
     * This is the main URL you will use to access the API’s endpoint
     */
    ENGINE_URL: string;
    /**
     * Auth Key - This is the authorization token on the integration page.
     * This token is used to authorize your access to the Mind Expression API.
     */
    AUTH_KEY: string;
    /**
     * Show log area or not
     */
    showLogCheck?: boolean;
    /**
     * Config of storage for media upload, please just config one of:
     * @s3BucketConfig or @azureBlobStorageConfig or @firebaseStorageConfig
     * SDK will only choose one of them.
     */
    remoteStorageConfig: RemoteStorageConfig;
    /**
     * Show error message at bottom or not
     */
    showError?: boolean;
    /**
     * This is for test purpose only
     * - mockedMessages: temp message items
     */
    test?: {
        mockedMessages: ConversationData[];
    };
};
declare const MindAIExpressionChatUI: React.FC<MindAIExpressionChatUIProps>;
export default MindAIExpressionChatUI;
//# sourceMappingURL=MindAIExpressionChatUI.d.ts.map