export declare abstract class ErrorWithCode extends Error {
    /**Error code, this must be identical*/
    abstract code: number;
}
type MaybeErrorWithCode = ErrorWithCode | null | undefined;
/**
 * ConversationNotStartedError: Conversation not started
 *
 * @category Errors
 * @category generated
 */
export declare class ConversationNotStartedError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * LoggerNotExistError: Logger not existed, please try enable it
 *
 * @category Errors
 * @category generated
 */
export declare class LoggerNotExistError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * NotClassifiedError: The Mind Expression engine does not understand the message
 * within the conversation configurations.
 *
 * @category Errors
 * @category generated
 */
export declare class NotClassifiedError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * EmptyInputMessageError: Conversation not started
 *
 * @category Errors
 * @category generated
 */
export declare class EmptyInputMessageError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * ConversationTerminatedError: The message and response ends the current conversation.
 *
 * @category Errors
 * @category generated
 */
export declare class ConversationTerminatedError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * BadRequestError: Authorization or request data wrong, please check again.
 *
 * @category Errors
 * @category generated
 */
export declare class BadRequestError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * UnauthorizedError: Unauthorized.
 *
 * @category Errors
 * @category generated
 */
export declare class UnauthorizedError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * QueryIdDuplicatedError: query-id is duplicated.
 *
 * @category Errors
 * @category generated
 */
export declare class QueryIdDuplicatedError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * InternalServerError: Internal server error.
 *
 * @category Errors
 * @category generated
 */
export declare class InternalServerError extends ErrorWithCode {
    readonly code: number;
    readonly name: string;
    stack?: string | undefined;
    cause?: unknown;
    constructor();
}
/**
 * Attempts to resolve a custom error from the provided error code.
 * @category Errors
 * @category generated
 */
export declare function errorFromCode(code: number): MaybeErrorWithCode;
/**
 * Attempts to resolve a custom error from the provided error name
 * @category Errors
 * @category generated
 */
export declare function errorFromName(name: string): MaybeErrorWithCode;
export declare const MIGHT_NOT_ERROR_CODES: number[];
export {};
//# sourceMappingURL=index.d.ts.map